

   MEMBER('Maillist.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('MAILL003.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('MAILL002.INC'),ONCE        !Req'd for module callout resolution
                     END


Maillist_WindowAbout PROCEDURE                        !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
window               WINDOW('About the Mail Manager Program'),AT(,,253,98),FONT(,,COLOR:Silver,),COLOR(COLOR:Navy),IMM,ICON('MAIL10.ICO'),PALETTE(256),SYSTEM,GRAY,RESIZE,MDI
                       STRING('Maillist Manager'),AT(14,1),USE(?String1),TRN,FONT('Arial',26,,FONT:bold+FONT:italic)
                       STRING('Version 2.0'),AT(153,9,43,10),USE(?String7),CENTER,FONT('Arial',12,,FONT:bold)
                       STRING('Developed using'),AT(46,19),USE(?String5),CENTER,FONT('Arial',10,,FONT:bold+FONT:italic)
                       STRING('Clarion 5 - Professional Edition'),AT(19,28),USE(?String6),FONT('Arial',12,,FONT:bold)
                       LINE,AT(8,45,146,0),USE(?Line1),COLOR(COLOR:Silver),LINEWIDTH(5)
                       REGION,AT(169,25,59,46),USE(?Region1),CURSOR('GLOVE.CUR')
                       IMAGE('SUE.GIF'),AT(161,22,84,71),USE(?Image1)
                       STRING('Created by'),AT(60,53),USE(?String2),TRN,CENTER,FONT('Arial',10,,FONT:bold+FONT:italic)
                       STRING('Sue Bostic'),AT(56,62),USE(?String3),TRN,CENTER,FONT('Arial',12,,FONT:bold+FONT:italic)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_WindowAbout')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(window)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_WindowAbout',window)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Maillist_WindowAbout',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Region1
      WindowSB()
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

Maillist_ReportMailingList PROCEDURE                  !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
FullName             STRING(45)
FooterText           STRING(40)
ReportDate           LONG
Progress:Thermometer BYTE
Process:View         VIEW(Mailers)
                       PROJECT(MAI:Description)
                       PROJECT(MAI:MailerNotes)
                       PROJECT(MAI:MailerNumber)
                       JOIN(MAP:MailerNumberKey,MAI:MailerNumber)
                         PROJECT(MAP:IDNumber)
                         JOIN(PEO:CustomerNumberKey,MAP:IDNumber)
                           PROJECT(PEO:FirstName)
                           PROJECT(PEO:LastName)
                         END
                       END
                     END
ReportPageNumber     LONG,AUTO
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1000,979,7000,9260),PRE(RPT),THOUS
                       HEADER,AT(906,521,6990,448)
                         STRING('Mailing List Summary Information'),AT(1750,125,3667,292),USE(?String1),FONT('Arial',16,,FONT:bold+FONT:italic)
                       END
break1                 BREAK(MAI:Description)
                         HEADER,AT(,10,6990,385),COLOR(COLOR:Silver)
                           STRING(@s20),AT(177,63),USE(MAI:Description),FONT('Arial',12,,FONT:bold)
                           TEXT,AT(2438,73,4438,177),USE(MAI:MailerNotes),FONT('Arial',10,,FONT:regular),RESIZE
                         END
detail                   DETAIL,AT(10,,3406,177),USE(?detail),FONT('Arial',10,,FONT:regular)
                           STRING(@s45),AT(10,0,3313,208),USE(FullName)
                         END
                         FOOTER,WITHPRIOR(1),AT(,,,438),FONT('Arial',12,,FONT:bold)
                           LINE,AT(10,260,6938,0),USE(?Line1),COLOR(COLOR:Black),LINEWIDTH(2)
                           STRING(@n3),AT(3896,10,323,208),CNT,RESET(break1),USE(PEO:LastName)
                           STRING(@s40),AT(63,10,3802,240),USE(FooterText)
                         END
                       END
                       FOOTER,AT(1000,10271,7021,333),FONT('Arial',10,,FONT:regular)
                         STRING('Report Date:'),AT(188,73),USE(?ReportDatePrompt),TRN
                         STRING('<<-- Date Stamp -->'),AT(1188,73),USE(?ReportDateStamp),TRN
                         STRING(@N3),AT(6542,73),USE(ReportPageNumber)
                         STRING('Page'),AT(6177,73),USE(?String9),TRN
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
OpenReport             PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_ReportMailingList')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Mailers.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_ReportMailingList',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Mailers, ?Progress:PctText, Progress:Thermometer, ProgressMgr, MAI:MailerNumber)
  ThisReport.AddSortOrder(MAI:MailerNumberKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Mailers.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Mailers.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_ReportMailingList',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.OpenReport PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.OpenReport()
  IF ~ReturnValue
    SELF.Report $ ?ReportDateStamp{PROP:Text}=FORMAT(TODAY(),@D17)
  END
  IF ~ReturnValue
    Report$?ReportPageNumber{PROP:PageNo}=True
  END
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  MAP:MailerNumber = MAI:MailerNumber                 ! Assign linking field value
  Access:MailPeople.Fetch(MAP:MailerNumberKey)
  PEO:IDNumber = MAP:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  MAP:MailerNumber = MAI:MailerNumber                 ! Assign linking field value
  Access:MailPeople.Fetch(MAP:MailerNumberKey)
  PEO:IDNumber = MAP:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FullName = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  FooterText = 'Total for ' & CLIP(MAI:Description) & ' Mailing List: '
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Maillist_ReportPeopleAlpha PROCEDURE                  !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
FullCustName         STRING(60)
AlphaHeader          STRING(1)
CityStateZip         STRING(30)
ReportDate           LONG
Progress:Thermometer BYTE
Process:View         VIEW(People)
                       PROJECT(PEO:Birthdate)
                       PROJECT(PEO:City)
                       PROJECT(PEO:FirstName)
                       PROJECT(PEO:LastName)
                       PROJECT(PEO:MiddleInitial)
                       PROJECT(PEO:NameSuffix)
                       PROJECT(PEO:Salutation)
                       PROJECT(PEO:State)
                       PROJECT(PEO:ZipCode)
                     END
ReportPageNumber     LONG,AUTO
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1000,1240,6000,9198),PRE(RPT),THOUS
                       HEADER,AT(979,500,6000,552)
                         STRING('Alphabetical Listing of People'),AT(1625,188,3250,281),USE(?String1),FONT('Arial',16,,FONT:bold+FONT:italic)
                       END
break1                 BREAK(AlphaHeader)
                         HEADER,AT(,,,281),COLOR(COLOR:Silver)
                           STRING(@s1),AT(2896,31),USE(AlphaHeader),TRN,CENTER,FONT('Arial',12,,FONT:bold+FONT:italic)
                         END
detail                   DETAIL,AT(,,2990,625),USE(?detail),FONT('Arial',8,,FONT:regular)
                           STRING(@s60),AT(73,42,2885,208),USE(FullCustName),TRN
                           STRING(@s30),AT(73,198),USE(CityStateZip),TRN
                           STRING(@d2),AT(552,354),USE(PEO:Birthdate)
                           STRING('Birthday:'),AT(73,354,500,177),USE(?String7)
                         END
                       END
                       FOOTER,AT(979,10448,6000,250),FONT('Arial',10,,FONT:regular)
                         STRING('Page No:'),AT(4229,31),USE(?String10)
                         STRING(@N3),AT(4854,31),USE(ReportPageNumber)
                         STRING('Report Date:'),AT(188,31),USE(?ReportDatePrompt),TRN
                         STRING('<<-- Date Stamp -->'),AT(1188,31),USE(?ReportDateStamp),TRN
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
OpenReport             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_ReportPeopleAlpha')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:People.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_ReportPeopleAlpha',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:People, ?Progress:PctText, Progress:Thermometer, ProgressMgr, PEO:LastName)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(PEO:LastNameKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:People.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:People.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_ReportPeopleAlpha',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.OpenReport PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.OpenReport()
  IF ~ReturnValue
    SELF.Report $ ?ReportDateStamp{PROP:Text}=FORMAT(TODAY(),@D17)
  END
  IF ~ReturnValue
    Report$?ReportPageNumber{PROP:PageNo}=True
  END
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FullCustName = CLIP(PEO:Salutation) & ' ' & CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName) & ' ' & CLIP(PEO:NameSuffix)
  AlphaHeader = UPPER(SUB(PEO:LastName,1,1))
  CityStateZip = CLIP(PEO:City) & ', ' & CLIP(PEO:State) & ' ' & CLIP(PEO:ZipCode)
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Maillist_ReportStateCity PROCEDURE                    !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
FullCustName         STRING(60)
Peoplecount          SHORT
ReportDate           LONG
Progress:Thermometer BYTE
Process:View         VIEW(People)
                       PROJECT(PEO:City)
                       PROJECT(PEO:FirstName)
                       PROJECT(PEO:LastName)
                       PROJECT(PEO:NameSuffix)
                       PROJECT(PEO:Salutation)
                       PROJECT(PEO:State)
                       JOIN(STA:STATEKEY,PEO:State)
                         PROJECT(STA:NAME)
                       END
                     END
ReportPageNumber     LONG,AUTO
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(1000,1219,6000,9260),PRE(RPT),THOUS
                       HEADER,AT(969,490,6000,688)
                         STRING('People Listing'),AT(2208,42,1594,281),USE(?String1),FONT('Arial',16,,FONT:bold+FONT:italic)
                         STRING('By State and City'),AT(2260,302,1448,208),USE(?String2),FONT('Arial',12,,FONT:bold+FONT:italic)
                       END
break1                 BREAK(PEO:State)
                         HEADER,AT(,,5979,250),COLOR(COLOR:Silver)
                           STRING(@s25),AT(1760,21),USE(STA:NAME),TRN,CENTER,FONT('Arial',12,,FONT:bold+FONT:italic)
                         END
detail                   DETAIL,AT(,,,167),USE(?detail),FONT('Arial',10,,FONT:regular)
                           STRING(@s60),AT(260,0,3510,208),USE(FullCustName)
                           STRING(@s25),AT(3792,0),USE(PEO:City),LEFT
                         END
                         FOOTER,WITHPRIOR(1),AT(,,,333),FONT('Arial',10,,FONT:bold+FONT:italic)
                           STRING(@n-6),AT(2781,42),CNT,RESET(break1),USE(Peoplecount),TRN
                           STRING('People in'),AT(188,52,698,208),USE(?String6),TRN
                           STRING(@s25),AT(875,52,1885,208),USE(STA:NAME,,?STA:NAME:2),TRN
                           LINE,AT(115,21,5677,0),USE(?Line2),COLOR(COLOR:Black),LINEWIDTH(2)
                         END
                       END
                       FOOTER,AT(990,10500,6000,250),FONT('Arial',10,,FONT:regular)
                         STRING('Page No:'),AT(4333,31),USE(?String11)
                         STRING('Report Date:'),AT(104,31),USE(?ReportDatePrompt),TRN
                         STRING('<<-- Date Stamp -->'),AT(1104,31),USE(?ReportDateStamp),TRN
                         STRING(@N3),AT(4990,31),USE(ReportPageNumber)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
OpenReport             PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_ReportStateCity')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:People.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_ReportStateCity',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:People, ?Progress:PctText, Progress:Thermometer, ProgressMgr, PEO:State)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(PEO:StateKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:People.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:People.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_ReportStateCity',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.OpenReport PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.OpenReport()
  IF ~ReturnValue
    SELF.Report $ ?ReportDateStamp{PROP:Text}=FORMAT(TODAY(),@D17)
  END
  IF ~ReturnValue
    Report$?ReportPageNumber{PROP:PageNo}=True
  END
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  STA:CODE = PEO:State                                ! Assign linking field value
  Access:STATES.Fetch(STA:STATEKEY)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  STA:CODE = PEO:State                                ! Assign linking field value
  Access:STATES.Fetch(STA:STATEKEY)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FullCustName = CLIP(PEO:Salutation) & ' ' & CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName) & ' ' & CLIP(PEO:NameSuffix)
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

SelectMailerForPrinting PROCEDURE                     !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(Mailers)
                       PROJECT(MAI:Description)
                       PROJECT(MAI:MailerNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
MAI:Description        LIKE(MAI:Description)          !List box control field - type derived from field
MAI:MailerNumber       LIKE(MAI:MailerNumber)         !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a Mailing List'),AT(,,158,206),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~SelectaMailingList'),SYSTEM,GRAY,MDI
                       LIST,AT(8,26,142,124),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Mailing Records'),TIP('Mailing list'),FORMAT('80L|M@s20@'),FROM(Queue:Browse:1)
                       BUTTON(' {17}&Select'),AT(9,153,141,22),USE(?Select:2),RIGHT,FONT('Arial',12,,FONT:bold),MSG('Select highlighted record'),TIP('Select highlighted record'),ICON('POINT01.ICO')
                       BUTTON('Close'),AT(4,180,70,19),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit window'),TIP('Exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(87,180,68,19),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,2,152,176),USE(?Panel1)
                       STRING('Type a letter to locate a specific mail list'),AT(9,5),USE(?String1)
                       STRING(@s20),AT(9,16),USE(MAI:Description)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectMailerForPrinting')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MailPeople.Open
  Access:People.UseFile
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Mailers,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,MAI:DescriptionKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?MAI:Description,MAI:Description,1,BRW1)
  BRW1.AddField(MAI:Description,BRW1.Q.MAI:Description)
  BRW1.AddField(MAI:MailerNumber,BRW1.Q.MAI:MailerNumber)
  INIMgr.Fetch('SelectMailerForPrinting',QuickWindow)
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectMailerForPrinting',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1

Maillist_WindowPickReport PROCEDURE                   !Generated from procedure template - Report

LocalRequest         LONG
LOC:MailerLowValue   LONG
LOC:MailerHighValue  LONG
FilesOpened          BYTE
FullName             STRING(50)
CityStateZip         STRING(50)
Progress:Thermometer BYTE
LOC:SpecificMailer   STRING(30)
LOC:CustomerType     STRING('''All'' {5}')
LOC:LabelStyle       STRING(15)
Process:View         VIEW(MailPeople)
                       PROJECT(MAP:MailerNumber)
                       PROJECT(MAP:IDNumber)
                       JOIN(PEO:CustomerNumberKey,MAP:IDNumber)
                         PROJECT(PEO:Address1)
                         PROJECT(PEO:Address2)
                         PROJECT(PEO:City)
                         PROJECT(PEO:FirstName)
                         PROJECT(PEO:LastName)
                         PROJECT(PEO:MiddleInitial)
                         PROJECT(PEO:NameSuffix)
                         PROJECT(PEO:Salutation)
                         PROJECT(PEO:State)
                         PROJECT(PEO:ZipCode)
                       END
                     END
Report2 REPORT,AT(250,250,8500,11000),PRE(RPT2),FONT('Arial',10,,FONT:regular),THOUS
break2 BREAK(MAP:MailerNumber)
detail   DETAIL,AT(,,4000,760),FONT('Arial',8,,FONT:regular)
           STRING(@s50),AT(73,31,3813,208),USE(FullName,,?S1),TRN
           STRING(@s35),AT(73,208,2604,208),USE(PEO:Address1,,?S2),TRN,LEFT
           STRING(@s35),AT(73,375,2635,208),USE(PEO:Address2,,?S3),SKIP,TRN,LEFT
           STRING(@s50),AT(73,552,3708,208),USE(CityStateZip,,?S4),TRN
         END
       END
     END

Report3 REPORT,AT(240,250,7969,10490),PRE(RPT3),FONT('Arial',10,,FONT:regular),THOUS
break3 BREAK(MAP:MailerNumber)
detail   DETAIL,AT(,,2625,760),FONT('Arial',8,,FONT:regular)
           STRING(@s50),AT(10,31,2583,208),USE(FullName,,?S5),TRN
           STRING(@s35),AT(21,198,2219,208),USE(PEO:Address1,,?S6),TRN,LEFT
           STRING(@s35),AT(21,375,2229,208),USE(PEO:Address2,,?S7),SKIP,TRN,LEFT
           STRING(@s50),AT(21,563,2563,208),USE(CityStateZip,,?S8),TRN
         END
       END
     END


ProgressWindow       WINDOW('Address Label Criteria'),AT(,,181,141),CENTER,HLP('~LabelSelections'),TIMER(1),GRAY,DOUBLE,MDI
                       PROGRESS,USE(Progress:Thermometer),AT(30,98,111,12),RANGE(0,100)
                       STRING(''),AT(14,86,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(17,87,141,10),USE(?Progress:PctText),CENTER
                       BUTTON(' {13}Select A Mailing List'),AT(9,6,162,18),USE(?Lookup),LEFT,MSG('Select a Maling List from List'),TIP('Click here to Select a Mailing List'),ICON('MAIL10.ICO')
                       OPTION('Label Type'),AT(9,37,71,41),USE(LOC:LabelStyle),BOXED,MSG('Format of Label for Reporting'),TIP('Select a Label Type')
                         RADIO('One Column'),AT(14,47),USE(?LabelStyle:Radio1),VALUE('1')
                         RADIO('Two Columns'),AT(14,57),USE(?LabelStyle:Radio2),VALUE('2')
                         RADIO('Three Columns'),AT(14,67),USE(?LabelStyle:Radio3),VALUE('3')
                       END
                       OPTION('Customer Status'),AT(100,37,71,41),USE(LOC:CustomerType),BOXED
                         RADIO('All'),AT(105,47),USE(?LOC:CustomerType:Radio1),VALUE('A')
                         RADIO('Acitve'),AT(105,57),USE(?LOC:CustomerType:Radio2),VALUE('C')
                         RADIO('Inactive'),AT(105,67),USE(?LOC:CustomerType:Radio3),VALUE('I')
                       END
                       BUTTON('Help'),AT(119,114,55,19),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Dispaly on-line help'),CURSOR(CURSOR:None),ICON(ICON:Help),STD(STD:Help)
                       BUTTON('Pause'),AT(62,114,55,19),USE(?Pause),LEFT,FONT('Arial',12,,FONT:bold),ICON('TRFFC10B.ICO')
                       PANEL,AT(3,3,174,79),USE(?Panel1)
                       STRING(@s30),AT(27,26),USE(LOC:SpecificMailer),CENTER,FONT('System',10,COLOR:Maroon,FONT:bold)
                       PANEL,AT(3,84,174,53),USE(?Panel2)
                       BUTTON('Close'),AT(5,114,55,19),USE(?Progress:Cancel),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),ICON('DOORWAY.ICO')
                     END

Report               REPORT,AT(240,229,7492,10500),PRE(RPT),FONT('Arial',10,,FONT:regular),THOUS
break1                 BREAK(MAP:MailerNumber)
detail                   DETAIL,AT(,,,758),USE(?detail),FONT('Arial',8,,FONT:regular)
                           STRING(@s50),AT(73,31,3156,208),USE(FullName),TRN,LEFT
                           STRING(@s35),AT(73,208,2604,208),USE(PEO:Address1),TRN,LEFT
                           STRING(@s35),AT(83,383,2635,208),USE(PEO:Address2),SKIP,TRN,LEFT
                           STRING(@s50),AT(63,552,3177,208),USE(CityStateZip),TRN,LEFT
                         END
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
OpenReport             PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Paused                 BYTE
Timer                  LONG
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
Cancelled              BYTE
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_WindowPickReport')
  LOC:LabelStyle = '1'
  LOC:CustomerType = 'A'
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  BIND('GLO:FilterString',GLO:FilterString)
  BIND('LOC:MailerHighValue',LOC:MailerHighValue)
  BIND('LOC:MailerLowValue',LOC:MailerLowValue)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:MailPeople.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_WindowPickReport',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:MailPeople, ?Progress:PctText, Progress:Thermometer, ProgressMgr, MAP:MailerNumber)
  ThisReport.AddSortOrder(MAP:MailerNumberKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:MailPeople.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  ASSERT(~SELF.DeferWindow) ! A hidden Go button is not smart ...
  SELF.DeferOpenReport = 1
  SELF.Timer = TARGET{PROP:Timer}
  TARGET{PROP:Timer} = 0
  ?Pause{PROP:Text} = 'Print'
  SELF.Paused = 1
  ?Progress:Cancel{PROP:Key} = EscKey
  !Change icon on button
  ?Pause{PROP:Icon} = 'trffc10a.ico'
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_WindowPickReport',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.OpenReport PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  CASE LOC:CustomerType
  OF 'A'
    SELF.PROCESS.SetFilter('MAP:MailerNumber >= LOC:MailerLowValue AND ' & |
                           'MAP:MailerNumber <<= LOC:MailerHighValue')
  OF 'C'
    SELF.PROCESS.SetFilter('MAP:MailerNumber >= LOC:MailerLowValue AND ' & |
                           'MAP:MailerNumber <<= LOC:MailerHighValue AND MAP:Status = ''Active''')
  OF 'I'
    SELF.PROCESS.SetFilter('MAP:MailerNumber >= LOC:MailerLowValue AND ' & |
                           'MAP:MailerNumber <<= LOC:MailerHighValue AND MAP:Status = ''Inactive''')
  END
  EXECUTE LOC:LabelStyle
    SELF.Report &= Report
    SELF.Report &= Report2
    SELF.Report &= Report3
  END
  ReturnValue = PARENT.OpenReport()
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  PEO:IDNumber = MAP:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)
  PARENT.Reset(Force)


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Pause
      IF SELF.Paused
      ! Check that a Maillist was chosen
      If ~LOC:SpecificMailer
        BEEP
        SELECT(?Lookup)
        CYCLE
      END
        TARGET{PROP:Timer} = SELF.Timer
        ?Pause{PROP:Text} = 'Pause'
       !Change icon on button
       ?Pause{PROP:Icon} = 'trffc10b.ico'
      ELSE
        SELF.Timer = TARGET{PROP:Timer}
        TARGET{PROP:Timer} = 0
        ?Pause{PROP:Text} = 'Restart'
      END
      SELF.Paused = 1 - SELF.Paused
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Lookup
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectMailerForPrinting
      ThisWindow.Reset
      !Update variables for specific mail list
      LOC:SpecificMailer = MAI:Description        !Show name on screen
      LOC:MailerLowValue = MAI:MailerNumber       !Assign filter criteria for report
      LOC:MailerHighValue = MAI:MailerNumber
    OF ?Progress:Cancel
      ThisWindow.Update
      SELF.Cancelled = 1
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:CloseWindow
      SELF.KeepVisible = 1
    OF EVENT:Timer
      IF SELF.Paused THEN RETURN Level:Benign .
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:CloseWindow
      IF ~SELF.Cancelled
        Progress:Thermometer = 0
        ?Progress:PctText{PROP:Text} = '0% Completed'
        SELF.DeferOpenReport = 1
        TARGET{PROP:Timer} = 0
        ?Pause{PROP:Text} = 'Print'
        SELF.Paused = 1
        SELF.Process.Close
        SELF.Response = RequestCancelled
      ! change button on icon
      ?Pause{PROP:Icon} = 'trffc10a.ico'
        DISPLAY
        RETURN Level:Notify
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  PEO:IDNumber = MAP:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  FullName = CLIP(PEO:Salutation) & ' ' & CLIP(PEO:FirstName) & ' ' & CLIP(PEO:MiddleInitial) & '  ' & CLIP(PEO:LastName) & ' ' & CLIP(PEO:NameSuffix)
  CityStateZip = CLIP(PEO:City) & ' ' & CLIP(PEO:State) & '   ' & CLIP(PEO:ZipCode)
  ReturnValue = PARENT.TakeRecord()
  FullName = CLIP(PEO:Salutation) & ' ' & CLIP(PEO:FirstName) & ' ' & CLIP(PEO:MiddleInitial) & '  ' & CLIP(PEO:LastName) & ' ' & CLIP(PEO:NameSuffix)
  CityStateZip = CLIP(PEO:City) & ' ' & CLIP(PEO:State) & '   ' & CLIP(PEO:ZipCode)
  EXECUTE LOC:LabelStyle
  PRINT(RPT:detail)
    PRINT(RPT2:detail)
    PRINT(RPT3:detail)
  END
  RETURN ReturnValue

Maillist_ReportPeopleKeys PROCEDURE                   !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:FullName         STRING(20)
ReportDate           LONG
Progress:Thermometer BYTE
Process:View         VIEW(PeopleKeys)
                       PROJECT(PKW:KeyWordDescription)
                       PROJECT(PKW:KeyWordNumber)
                       PROJECT(PKW:IDNumber)
                       JOIN(KEY:KeyWordNumberKey,PKW:KeyWordNumber)
                       END
                       JOIN(PEO:CustomerNumberKey,PKW:IDNumber)
                         PROJECT(PEO:FirstName)
                         PROJECT(PEO:LastName)
                       END
                     END
ReportPageNumber     LONG,AUTO
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT,AT(500,1052,7000,9427),PRE(RPT),FONT('Arial',10,,FONT:regular),THOUS
                       HEADER,AT(917,490,6490,552)
                         STRING('Members of Keyword Groups'),AT(1323,21,4042,354),USE(?String4),FONT('Arial',20,,FONT:bold+FONT:italic)
                       END
break1                 BREAK(PKW:KeyWordNumber)
                         HEADER,AT(,,,260),COLOR(COLOR:Silver)
                           STRING(@s30),AT(2031,31),USE(PKW:KeyWordDescription),CENTER,FONT('Arial',12,,FONT:bold+FONT:italic)
                         END
detail                   DETAIL,AT(,,3479,188),USE(?detail)
                           STRING(@s40),AT(31,0,3385,208),USE(LOC:FullName)
                         END
                       END
                       FOOTER,AT(1010,10490,6490,229),FONT('Arial',10,,FONT:regular)
                         STRING('Page No:'),AT(4510,10,573,208),USE(?String5)
                         STRING('Report Date:'),AT(198,10),USE(?ReportDatePrompt),TRN
                         STRING('<<-- Date Stamp -->'),AT(1198,10),USE(?ReportDateStamp),TRN
                         STRING(@N3),AT(5156,10),USE(ReportPageNumber)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
OpenReport             PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_ReportPeopleKeys')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:PeopleKeys.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_ReportPeopleKeys',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:PeopleKeys, ?Progress:PctText, Progress:Thermometer, ProgressMgr, PKW:KeyWordNumber)
  ThisReport.AddSortOrder(PKW:KeyWordNumberKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:PeopleKeys.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:PeopleKeys.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_ReportPeopleKeys',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.OpenReport PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.OpenReport()
  IF ~ReturnValue
    Report$?ReportPageNumber{PROP:PageNo}=True
  END
  IF ~ReturnValue
    SELF.Report $ ?ReportDateStamp{PROP:Text}=FORMAT(TODAY(),@D17)
  END
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  KEY:KeyWordNumber = PKW:KeyWordNumber               ! Assign linking field value
  Access:KeyWords.Fetch(KEY:KeyWordNumberKey)
  PEO:IDNumber = PKW:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  KEY:KeyWordNumber = PKW:KeyWordNumber               ! Assign linking field value
  Access:KeyWords.Fetch(KEY:KeyWordNumberKey)
  PEO:IDNumber = PKW:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  LOC:FullName = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Maillist_SplashScreen PROCEDURE                       !Generated from procedure template - Splash

LocalRequest         LONG
FilesOpened          BYTE
window               WINDOW,AT(,,204,94),FONT('MS Sans Serif',8,,FONT:regular),CENTER,GRAY,NOFRAME,MDI
                       PANEL,AT(0,0,204,95),BEVEL(6)
                       PANEL,AT(7,6,191,83),BEVEL(-2,1)
                       STRING('Mailing List Manager'),AT(11,12,184,20),USE(?String2),CENTER,FONT('Arial',20,COLOR:Navy,FONT:bold+FONT:italic)
                       IMAGE('sv_small.jpg'),AT(61,44,82,42),USE(?Image1),CENTERED
                       PANEL,AT(12,29,182,12),BEVEL(-1,1,09H)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_SplashScreen')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String2
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(window)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_SplashScreen',window)
  TARGET{Prop:Timer} = 500
  TARGET{Prop:Alrt,255} = MouseLeft
  TARGET{Prop:Alrt,254} = MouseLeft2
  TARGET{Prop:Alrt,253} = MouseRight
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Maillist_SplashScreen',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF MouseLeft
      OROF MouseLeft2
      OROF MouseRight
        POST(Event:CloseWindow)
      END
    OF EVENT:LoseFocus
        POST(Event:CloseWindow)
    OF Event:Timer
      POST(Event:CloseWindow)
    OF Event:AlertKey
      CASE KEYCODE()
      OF MouseLeft
      OROF MouseLeft2
      OROF MouseRight
        POST(Event:CloseWindow)
      END
    ELSE
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

