

   MEMBER('Eventmgr.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABDROPS.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EVENT001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EVENT002.INC'),ONCE        !Req'd for module callout resolution
                     END


Eventmgr_BrowseEvents PROCEDURE                       !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LOC:Running:BrowseEvents LONG(0)
BRW1::View:Browse    VIEW(Events)
                       PROJECT(EVE:Description)
                       PROJECT(EVE:Date)
                       PROJECT(EVE:Number)
                       PROJECT(EVE:Sponsor)
                       JOIN(SPO:KeySponsorNumber,EVE:Sponsor)
                         PROJECT(SPO:CompanyName)
                         PROJECT(SPO:SponsorNumber)
                       END
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
EVE:Description        LIKE(EVE:Description)          !List box control field - type derived from field
EVE:Date               LIKE(EVE:Date)                 !List box control field - type derived from field
SPO:CompanyName        LIKE(SPO:CompanyName)          !List box control field - type derived from field
EVE:Number             LIKE(EVE:Number)               !Primary key field - type derived from field
SPO:SponsorNumber      LIKE(SPO:SponsorNumber)        !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Events'),AT(,,305,188),FONT('MS Sans Serif',8,,),CENTER,IMM,ICON('EVENT.ICO'),HLP('~BrowseEvents'),SYSTEM,GRAY,MAX,RESIZE,MDI
                       LIST,AT(8,20,292,124),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('80L(2)|M~Description~@S25@53R(2)|M~Date~C(0)@d2@100L(2)|M~Sponsor~@S25@'),FROM(Queue:Browse:1)
                       BUTTON('&Select'),AT(9,170,45,14),USE(?Select:2)
                       BUTTON('&Insert'),AT(48,106,45,14),USE(?Insert:3),HIDE
                       BUTTON('&Change'),AT(97,106,45,14),USE(?Change:3),HIDE,DEFAULT
                       BUTTON('&Delete'),AT(146,106,45,14),USE(?Delete:3),HIDE
                       SHEET,AT(4,4,299,162),USE(?CurrentTab)
                         TAB('By Description')
                         END
                         TAB('By Event Date')
                         END
                       END
                       BUTTON('Close'),AT(205,170,45,14),USE(?Close)
                       BUTTON('Help'),AT(255,170,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeNewSelection       PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort1:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
BRW1::Sort1:StepClass StepLongClass                   !Conditional Step Manager - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_BrowseEvents')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  ALERT(F3Key,F6Key)   !Alert Procedure Hot Keys
  !!Limit Procedure to only one instance
   IF GlobalRequest<>SelectRecord
     IF NOT GLO:Running:BrowseEvents     !If its not running
        GLO:Running:BrowseEvents=THREAD()  !Set global var to indicate this instance is running
        LOC:Running:BrowseEvents=THREAD()  !Set Local var to indicate this instance is running
      ELSE                                 !If it is running
        POST(Event:GainFocus,,GLO:Running:BrowseEvents) !bring to front
        RETURN Level:Fatal  !don't continute this with this instance
      END
    END
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:Events.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Events,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort1:StepClass.Init(+ScrollSort:AllowAlpha+ScrollSort:Descending)
  BRW1.AddSortOrder(BRW1::Sort1:StepClass,EVE:KeyDate)
  BRW1.AddLocator(BRW1::Sort1:Locator)
  BRW1::Sort1:Locator.Init(,EVE:Date,1,BRW1)
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,EVE:KeyDescription)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,EVE:Description,1,BRW1)
  BRW1.AddField(EVE:Description,BRW1.Q.EVE:Description)
  BRW1.AddField(EVE:Date,BRW1.Q.EVE:Date)
  BRW1.AddField(SPO:CompanyName,BRW1.Q.SPO:CompanyName)
  BRW1.AddField(EVE:Number,BRW1.Q.EVE:Number)
  BRW1.AddField(SPO:SponsorNumber,BRW1.Q.SPO:SponsorNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Eventmgr_BrowseEvents',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Events.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_BrowseEvents',QuickWindow)
  END
  !!Reset Thread Limiting flag on exit
  IF LOC:Running:BrowseEvents
     GLO:Running:BrowseEvents=0
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    UpdateEvents
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeNewSelection PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?CurrentTab
      !Format Browse to display sort field in first column
      CASE CHOICE(?CurrentTab)
      OF 1
         ?BROWSE:1{PROP:Format}= '80L(2)|M~Description~@S25@#1#' & |
                                 '53R(2)|M~Date~C(0)@d2@#2#' & |
                                 '100L(2)|M~Sponsor~L(0)@S25@#3#'
      OF 2
         ?BROWSE:1{PROP:Format}= '53R(2)|M~Date~C(0)@d2@#2#' & |
                                 '80L(2)|M~Description~@S25@#1#' & |
                                 '100L(2)|M~Sponsor~L(0)@S25@#3#'
      END
      
    END
  ReturnValue = PARENT.TakeNewSelection()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:AlertKey
      !Handle All Procedure HotKeys
      CASE KEYCODE()
        OF F3Key
            POST(EVENT:Accepted,GLO:MemberButton,GLO:AppFrameThread)
        OF F4Key
            POST(EVENT:Accepted,GLO:VendorButton,GLO:AppFrameThread)
        OF F5Key
            POST(EVENT:Accepted,GLO:EventButton,GLO:AppFrameThread)
        OF F6Key
            POST(EVENT:Accepted,GLO:SponsorButton,GLO:AppFrameThread)
      END
    OF EVENT:GainFocus
      !!Bring to front and restore to normal size if iconized
      quickwindow{PROP:Active}=TRUE
      IF quickwindow{PROP:Iconize}=TRUE
        quickwindow{PROP:Iconize}=''
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

AssignTables PROCEDURE                                !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
LOC:EventNumber      LONG(1)
LOC:AttendeeCounter  LONG
LOC:RemainingToAssign LONG
Loc:TableCounter     BYTE,DIM(20)
LOC:Running:Assigntables LONG(0)
BRW1::View:Browse    VIEW(Attendees)
                       PROJECT(ATT:EventNumber)
                       PROJECT(ATT:TableNumber)
                       PROJECT(ATT:Attendee)
                       JOIN(MEM:MemberNumberKey,ATT:Attendee)
                         PROJECT(MEM:LastName)
                         PROJECT(MEM:FirstName)
                         PROJECT(MEM:MemberNumber)
                       END
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
MEM:LastName           LIKE(MEM:LastName)             !List box control field - type derived from field
MEM:FirstName          LIKE(MEM:FirstName)            !List box control field - type derived from field
ATT:EventNumber        LIKE(ATT:EventNumber)          !Primary key field - type derived from field
ATT:TableNumber        LIKE(ATT:TableNumber)          !Primary key field - type derived from field
ATT:Attendee           LIKE(ATT:Attendee)             !Primary key field - type derived from field
MEM:MemberNumber       LIKE(MEM:MemberNumber)         !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW3::View:Browse    VIEW(Attendees)
                       PROJECT(ATT:EventNumber)
                       PROJECT(ATT:TableNumber)
                       PROJECT(ATT:Attendee)
                       JOIN(MEM:MemberNumberKey,ATT:Attendee)
                         PROJECT(MEM:LastName)
                         PROJECT(MEM:FirstName)
                         PROJECT(MEM:MemberNumber)
                       END
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?List:2
MEM:LastName           LIKE(MEM:LastName)             !List box control field - type derived from field
MEM:FirstName          LIKE(MEM:FirstName)            !List box control field - type derived from field
ATT:EventNumber        LIKE(ATT:EventNumber)          !Primary key field - type derived from field
ATT:TableNumber        LIKE(ATT:TableNumber)          !Primary key field - type derived from field
ATT:Attendee           LIKE(ATT:Attendee)             !Primary key field - type derived from field
MEM:MemberNumber       LIKE(MEM:MemberNumber)         !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
window               WINDOW('Seating for Event'),AT(,,280,166),FONT('MS Sans Serif',8,,),CENTER,ICON('T.ICO'),HLP('~SeatingForEvent'),SYSTEM,GRAY,RESIZE,AUTO,MDI,IMM
                       GROUP('Table Assignments'),AT(2,1,159,162),USE(?Group1),BOXED
                         STRING('Seated at this Table'),AT(57,142),USE(?String2)
                       END
                       SHEET,AT(5,12,153,148),USE(?Sheet1),ABOVE(12)
                         TAB('&1'),USE(?Tab1),HIDE
                         END
                         TAB('&2'),USE(?Tab2),HIDE
                         END
                         TAB('&3'),USE(?Tab3),HIDE
                         END
                         TAB('&4'),USE(?Tab4),HIDE
                         END
                         TAB('&5'),USE(?Tab5),HIDE
                         END
                         TAB('&6'),USE(?Tab6),HIDE
                         END
                         TAB('&7'),USE(?Tab7),HIDE
                         END
                         TAB('&8'),USE(?Tab8),HIDE
                         END
                         TAB('&9'),USE(?Tab9),HIDE
                         END
                         TAB('1&0'),USE(?Tab10),HIDE
                         END
                         TAB('1&1'),USE(?Tab11),HIDE
                         END
                         TAB('12'),USE(?Tab12),HIDE
                         END
                         TAB('13'),USE(?Tab13),HIDE
                         END
                         TAB('14'),USE(?Tab14),HIDE
                         END
                         TAB('15'),USE(?Tab15),HIDE
                         END
                         TAB('16'),USE(?Tab16),HIDE
                         END
                         TAB('17'),USE(?Tab17),HIDE
                         END
                         TAB('18'),USE(?Tab18),HIDE
                         END
                         TAB('19'),USE(?Tab19),HIDE
                         END
                         TAB('20'),USE(?Tab20),HIDE
                         END
                       END
                       BUTTON('&<<'),AT(162,37,18,14),USE(?Button7)
                       BUTTON('&>'),AT(162,54,18,14),USE(?Button7:2)
                       STRING(@n4),AT(36,142),USE(LOC:AttendeeCounter),RIGHT
                       BUTTON('Close'),AT(247,150),USE(?Close)
                       STRING('Unassigned'),AT(201,151),USE(?String2:2)
                       STRING(@n4),AT(180,151),USE(LOC:RemainingToAssign)
                       LIST,AT(11,41,144,94),USE(?List:2),IMM,VSCROLL,MSG('Browsing Records'),CURSOR('FINGER.CUR'),FORMAT('58L(1)|M~LastName~@s25@80L(1)|M~FirstName~@s20@'),FROM(Queue:Browse:1),DRAGID('ToZero'),DROPID('FromZero')
                       LIST,AT(182,3,97,142),USE(?List),IMM,VSCROLL,MSG('Browsing Records'),CURSOR('FINGER.CUR'),FORMAT('41L(1)|M~LastName~@s25@80L(1)|M~FirstName~@s20@'),FROM(Queue:Browse),DRAGID('FromZero'),DROPID('ToZero')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ZeroBrowse           CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
ResetFromView          PROCEDURE(),DERIVED
TakeKey                PROCEDURE(),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
TableBrowse          CLASS(BrowseClass)               !Browse using ?List:2
Q                      &Queue:Browse:1                !Reference to browse queue
ResetFromView          PROCEDURE(),DERIVED
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
TakeKey                PROCEDURE(),BYTE,PROC,DERIVED
                     END

BRW3::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW3::Sort1:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=1
BRW3::Sort2:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=2
BRW3::Sort3:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=3
BRW3::Sort4:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=4
BRW3::Sort5:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=5
BRW3::Sort6:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=6
BRW3::Sort7:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=7
BRW3::Sort8:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=8
BRW3::Sort9:Locator  StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=9
BRW3::Sort10:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=10
BRW3::Sort11:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=11
BRW3::Sort12:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=12
BRW3::Sort13:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=13
BRW3::Sort14:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=14
BRW3::Sort15:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=15
BRW3::Sort16:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=16
BRW3::Sort17:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=17
BRW3::Sort18:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=18
BRW3::Sort19:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=19
BRW3::Sort20:Locator StepLocatorClass                 !Conditional Locator - CHOICE(?Sheet1)=20

  CODE
  GlobalResponse = ThisWindow.Run()

DragFromTable   ROUTINE
! This Routine Gets the record for the Highlighted item in the Table
! List
! so a person can be moved to the unassigned list
! This is used by the >> button or Event Drag from a Table
  GET(QUEUE:BROWSE:1,CHOICE(?List:2))
  ATT:EventNumber=TableBrowse.Q.ATT:EventNumber
  ATT:TableNumber=TableBrowse.Q.ATT:TableNumber
  ATT:Attendee = TableBrowse.Q.ATT:Attendee                    !Initialize key fields
  Access:Attendees.Fetch(ATT:KEYEventTableAttendee)     ! get record with matching value
DragFromZero   ROUTINE
! This Routine Gets the record for the Highlighted item in the
! Unassigned List
! so a person can be assigned to a Table
! This is used by the << button or Event Drag from the Unassigned
! List
  GET(QUEUE:BROWSE,CHOICE(?List))
  ATT:EventNumber=ZeroBrowse.Q.ATT:EventNumber
  ATT:TableNumber=ZeroBrowse.Q.ATT:TableNumber
  ATT:Attendee = ZeroBrowse.Q.ATT:Attendee                    !Initialize key fields
  Access:Attendees.Fetch(ATT:KEYEventTableAttendee)     ! get record with matching value
DropOnZero    ROUTINE
! This Routine changes the value of TableNumber to 0 (making the
! person unassigned)
!
! This is used by the >> button or Event Drag from a table if
! followed by a drop
  ATT:TableNumber=0
  IF Access:Attendees.Update() THEN STOP(ERROR()).
  Loc:TableCounter[CHOICE(?Sheet1)] -= 1
  DO CheckSeatLimit
  ZeroBrowse.Reset(3)
  ZeroBrowse.ResetQueue(Reset:Done)
  ThisWindow.Reset(TRUE)
  ThisWindow.Reset(TRUE)
DropOnTable    ROUTINE
! This Routine changes the value of TableNumber to the current table
! assigning the person to a table
! This is used by the << button or Event Drag from unassigned if
! followed by a drop on a table
  IF LOC:AttendeeCounter >=EVE:SeatsPerTable
    Message('Sorry, This Table is Full. Try Another')
    EXIT  
  END
  ATT:TableNumber=CHOICE(?Sheet1)
  IF Access:Attendees.Update() THEN STOP(ERROR()).
  Loc:TableCounter[CHOICE(?Sheet1)] += 1
  DO CheckSeatLimit
  TableBrowse.Reset(3)
  TableBrowse.ResetQueue(Reset:Done)
  ThisWindow.Reset(TRUE)
! Check seating limits and colorize tab
! Red if Table is full, Black if not full
CheckSeatLimit ROUTINE
 LOOP i# = 1 TO 20
   IF Loc:TableCounter[i#] >= EVE:SeatsPerTable
     (?Tab1 + i# - 1){Prop:FontColor} = COLOR:RED    ! It's full, color it Red
   ELSE
     (?Tab1 + i# - 1){Prop:FontColor} = COLOR:BLACK  ! There's room here, color it Black
   END
 END
!Cycle through file and count attendees at each table
CountSeats ROUTINE
 CLEAR(Loc:TableCounter)                              !Clear the array
 ATT:EventNumber=LOC:EventNumber                      !Set Key Component values
 ATT:TableNumber=1
 ATT:Attendee=0
 SET(ATT:KeyEventTableAttendee,ATT:KeyEventTableAttendee)  !set key position
 LOOP UNTIL Access:Attendees.Next()
   IF ATT:EventNumber<>LOC:EventNumber THEN BREAK.         !Break out when reaches next event
   IF ATT:TableNumber
     Loc:TableCounter[ATT:TableNumber] += 1
   END
 END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('AssignTables')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String2
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  !!Limit Procedure to only one instance
  IF NOT GLO:Running:AssignTables         !If its not running
    GLO:Running:AssignTables=THREAD()     !Set global var to indicate this instance is running
    LOC:Running:AssignTables=THREAD()     !Set Local var to indicate this instance is running
  ELSE                                    !If it is running
    POST(Event:GainFocus,,GLO:Running:AssignTables) !bring to front
    RETURN Level:Fatal                    !don't continute this with this instance
  END
  LOC:EventNumber=EVE:Number
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:Attendees.Open
  Access:Events.UseFile
  SELF.FilesOpened = True
  ZeroBrowse.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Attendees,SELF)
  TableBrowse.Init(?List:2,Queue:Browse:1.ViewPosition,BRW3::View:Browse,Queue:Browse:1,Relate:Attendees,SELF)
  OPEN(window)
  SELF.Opened=True
  ZeroBrowse.Q &= Queue:Browse
  ZeroBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  ZeroBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  ZeroBrowse.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,ATT:TableNumber,1,ZeroBrowse)
  ZeroBrowse.SetFilter('(ATT:TableNumber=0)')
  ZeroBrowse.AddResetField(LOC:EventNumber)
  ZeroBrowse.AddField(MEM:LastName,ZeroBrowse.Q.MEM:LastName)
  ZeroBrowse.AddField(MEM:FirstName,ZeroBrowse.Q.MEM:FirstName)
  ZeroBrowse.AddField(ATT:EventNumber,ZeroBrowse.Q.ATT:EventNumber)
  ZeroBrowse.AddField(ATT:TableNumber,ZeroBrowse.Q.ATT:TableNumber)
  ZeroBrowse.AddField(ATT:Attendee,ZeroBrowse.Q.ATT:Attendee)
  ZeroBrowse.AddField(MEM:MemberNumber,ZeroBrowse.Q.MEM:MemberNumber)
  TableBrowse.Q &= Queue:Browse:1
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort1:Locator)
  BRW3::Sort1:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=1)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort2:Locator)
  BRW3::Sort2:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=2)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort3:Locator)
  BRW3::Sort3:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=3)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort4:Locator)
  BRW3::Sort4:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=4)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort5:Locator)
  BRW3::Sort5:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=5)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort6:Locator)
  BRW3::Sort6:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=6)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort7:Locator)
  BRW3::Sort7:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=7)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort8:Locator)
  BRW3::Sort8:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=8)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort9:Locator)
  BRW3::Sort9:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=9)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort10:Locator)
  BRW3::Sort10:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=10)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort11:Locator)
  BRW3::Sort11:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=11)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort12:Locator)
  BRW3::Sort12:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=12)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort13:Locator)
  BRW3::Sort13:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=13)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort14:Locator)
  BRW3::Sort14:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=14)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort15:Locator)
  BRW3::Sort15:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=15)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort16:Locator)
  BRW3::Sort16:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=16)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort17:Locator)
  BRW3::Sort17:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=17)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort18:Locator)
  BRW3::Sort18:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=18)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort19:Locator)
  BRW3::Sort19:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=19)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort20:Locator)
  BRW3::Sort20:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.SetFilter('(ATT:TableNumber=20)')
  TableBrowse.AddSortOrder(,ATT:KeyEventTableAttendee)
  TableBrowse.AddRange(ATT:EventNumber,LOC:EventNumber)
  TableBrowse.AddLocator(BRW3::Sort0:Locator)
  BRW3::Sort0:Locator.Init(,ATT:TableNumber,1,TableBrowse)
  TableBrowse.AddResetField(LOC:EventNumber)
  TableBrowse.AddField(MEM:LastName,TableBrowse.Q.MEM:LastName)
  TableBrowse.AddField(MEM:FirstName,TableBrowse.Q.MEM:FirstName)
  TableBrowse.AddField(ATT:EventNumber,TableBrowse.Q.ATT:EventNumber)
  TableBrowse.AddField(ATT:TableNumber,TableBrowse.Q.ATT:TableNumber)
  TableBrowse.AddField(ATT:Attendee,TableBrowse.Q.ATT:Attendee)
  TableBrowse.AddField(MEM:MemberNumber,TableBrowse.Q.MEM:MemberNumber)
  INIMgr.Fetch('AssignTables',window)
  window{Prop:Text}='Assign Seating for: ' & EVE:Description  !assign window caption
  DO CountSeats
  DO CheckSeatLimit
  UNHIDE(?Tab1,?Tab1 + EVE:MaxTables - 1)
  
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Attendees.Close
  END
  IF SELF.Opened
    INIMgr.Update('AssignTables',window)
  END
  IF LOC:Running:AssignTables
    GLO:Running:AssignTables = 0
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Button7
      ThisWindow.Update
      Do DragFromZero
      DO DropOnTable
      
    OF ?Button7:2
      ThisWindow.Update
      Do DragFromTable
      Do DropOnZero
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeFieldEvent()
  CASE FIELD()
  OF ?List:2
    CASE EVENT()
    OF EVENT:Dragging
      SETCURSOR(CHOOSE(DROPID() = 'ToZero','~dropmbr.cur',Cursor:NoDrop))
      
    OF EVENT:Drag
      SETCURSOR()   !reset the cursor
      
    OF EVENT:Drop
      ! Call Drag Routine and Drop Routine
      Do DragFromZero
      Do DropOnTable
      
    END
  OF ?List
    CASE EVENT()
    OF EVENT:Dragging
      !!Set Cursor
      IF DROPID() = 'FromZero'
        SETCURSOR('~dropmbr.cur')
      ELSE
        SETCURSOR(Cursor:NoDrop)
      END
      
    OF EVENT:Drag
        SETCURSOR()  !reset cursor
      
    OF EVENT:Drop
      !!Call Drag routine and drop routine
      Do DragFromTable
      Do DropOnZero
      
    END
  END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:GainFocus
      window{PROP:Active}=TRUE
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ZeroBrowse.ResetFromView PROCEDURE

LOC:RemainingToAssign:Cnt LONG
  CODE
  SETCURSOR(Cursor:Wait)
  Relate:Attendees.SetQuickScan(1)
  SELF.Reset
  LOOP
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      RETURN
    END
    SELF.SetQueueRecord
    LOC:RemainingToAssign:Cnt += 1
  END
  LOC:RemainingToAssign = LOC:RemainingToAssign:Cnt
  PARENT.ResetFromView
  Relate:Attendees.SetQuickScan(0)
  SETCURSOR()


ZeroBrowse.TakeKey PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  IF RECORDS(SELF.ListQueue)
    CASE KEYCODE()
    OF MouseLeft2
      Do DragFromZero
      Do DropOnTable
    END
  END
  
  ReturnValue = PARENT.TakeKey()
  RETURN ReturnValue


TableBrowse.ResetFromView PROCEDURE

LOC:AttendeeCounter:Cnt LONG
  CODE
  SETCURSOR(Cursor:Wait)
  Relate:Attendees.SetQuickScan(1)
  SELF.Reset
  LOOP
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      RETURN
    END
    SELF.SetQueueRecord
    LOC:AttendeeCounter:Cnt += 1
  END
  LOC:AttendeeCounter = LOC:AttendeeCounter:Cnt
  PARENT.ResetFromView
  Relate:Attendees.SetQuickScan(0)
  SETCURSOR()


TableBrowse.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?Sheet1)=1
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?Sheet1)=2
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?Sheet1)=3
    RETURN SELF.SetSort(3,Force)
  ELSIF CHOICE(?Sheet1)=4
    RETURN SELF.SetSort(4,Force)
  ELSIF CHOICE(?Sheet1)=5
    RETURN SELF.SetSort(5,Force)
  ELSIF CHOICE(?Sheet1)=6
    RETURN SELF.SetSort(6,Force)
  ELSIF CHOICE(?Sheet1)=7
    RETURN SELF.SetSort(7,Force)
  ELSIF CHOICE(?Sheet1)=8
    RETURN SELF.SetSort(8,Force)
  ELSIF CHOICE(?Sheet1)=9
    RETURN SELF.SetSort(9,Force)
  ELSIF CHOICE(?Sheet1)=10
    RETURN SELF.SetSort(10,Force)
  ELSIF CHOICE(?Sheet1)=11
    RETURN SELF.SetSort(11,Force)
  ELSIF CHOICE(?Sheet1)=12
    RETURN SELF.SetSort(12,Force)
  ELSIF CHOICE(?Sheet1)=13
    RETURN SELF.SetSort(13,Force)
  ELSIF CHOICE(?Sheet1)=14
    RETURN SELF.SetSort(14,Force)
  ELSIF CHOICE(?Sheet1)=15
    RETURN SELF.SetSort(15,Force)
  ELSIF CHOICE(?Sheet1)=16
    RETURN SELF.SetSort(16,Force)
  ELSIF CHOICE(?Sheet1)=17
    RETURN SELF.SetSort(17,Force)
  ELSIF CHOICE(?Sheet1)=18
    RETURN SELF.SetSort(18,Force)
  ELSIF CHOICE(?Sheet1)=19
    RETURN SELF.SetSort(19,Force)
  ELSIF CHOICE(?Sheet1)=20
    RETURN SELF.SetSort(20,Force)
  ELSE
    RETURN SELF.SetSort(21,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


TableBrowse.TakeKey PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  IF RECORDS(SELF.ListQueue)
    CASE KEYCODE()
    OF MouseLeft2
      Do DragFromTable
      Do DropOnZero
    END
  END
  
  ReturnValue = PARENT.TakeKey()
  RETURN ReturnValue

UpdateEvents PROCEDURE                                !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
LOC:DayOfWeek        STRING(10)
LOC:AttendeeCount    LONG
BudgetTotal          DECIMAL(7,2)
ActualTotal          DECIMAL(7,2)
BilledTotal          DECIMAL(7,2)
LOC:EventNumber      LONG
LOC:Saved:MaxTables  BYTE
LOC:Saved:SeatsPerTable BYTE
LOC:HighSeatCounter  BYTE
Loc:SeatCounter      BYTE,DIM(20)
LOC:MinTableCounter  BYTE
LOC:MemberName       STRING(50)
LOC:CSZ              STRING(50)
LOC:FullAddress      STRING(200)
BRW2::View:Browse    VIEW(Attendees)
                       PROJECT(ATT:TableNumber)
                       PROJECT(ATT:EventNumber)
                       PROJECT(ATT:Attendee)
                       JOIN(MEM:MemberNumberKey,ATT:Attendee)
                         PROJECT(MEM:Address)
                         PROJECT(MEM:Address2)
                         PROJECT(MEM:MemberNumber)
                       END
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
ATT:TableNumber        LIKE(ATT:TableNumber)          !List box control field - type derived from field
LOC:MemberName         LIKE(LOC:MemberName)           !List box control field - type derived from local data
MEM:Address            LIKE(MEM:Address)              !Browse hot field - type derived from field
MEM:Address2           LIKE(MEM:Address2)             !Browse hot field - type derived from field
LOC:CSZ                LIKE(LOC:CSZ)                  !Browse hot field - type derived from local data
LOC:FullAddress        LIKE(LOC:FullAddress)          !Browse hot field - type derived from local data
ATT:EventNumber        LIKE(ATT:EventNumber)          !Primary key field - type derived from field
ATT:Attendee           LIKE(ATT:Attendee)             !Primary key field - type derived from field
MEM:MemberNumber       LIKE(MEM:MemberNumber)         !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW10::View:Browse   VIEW(MPhones)
                       PROJECT(MPH:Description)
                       PROJECT(MPH:PhoneNumber)
                       PROJECT(MPH:MemberNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
MPH:Description        LIKE(MPH:Description)          !List box control field - type derived from field
MPH:PhoneNumber        LIKE(MPH:PhoneNumber)          !List box control field - type derived from field
MPH:MemberNumber       LIKE(MPH:MemberNumber)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW4::View:Browse    VIEW(LineItems)
                       PROJECT(LIN:BudgetCost)
                       PROJECT(LIN:ActualCost)
                       PROJECT(LIN:BillPrice)
                       PROJECT(LIN:ItemTypeCode)
                       PROJECT(LIN:Quantity)
                       PROJECT(LIN:Description)
                       PROJECT(LIN:EventNumber)
                       PROJECT(LIN:LineNumber)
                       PROJECT(LIN:Vendor)
                       JOIN(VEN:KeyVendorNumber,LIN:Vendor)
                         PROJECT(VEN:CompanyName)
                         PROJECT(VEN:VendorNumber)
                       END
                     END
Queue:Browse:4       QUEUE                            !Queue declaration for browse/combo box using ?Browse:4
LIN:BudgetCost         LIKE(LIN:BudgetCost)           !List box control field - type derived from field
LIN:BudgetCost_NormalFG LONG                          !Normal forground color
LIN:BudgetCost_NormalBG LONG                          !Normal background color
LIN:BudgetCost_SelectedFG LONG                        !Selected forground color
LIN:BudgetCost_SelectedBG LONG                        !Selected background color
LIN:ActualCost         LIKE(LIN:ActualCost)           !List box control field - type derived from field
LIN:ActualCost_NormalFG LONG                          !Normal forground color
LIN:ActualCost_NormalBG LONG                          !Normal background color
LIN:ActualCost_SelectedFG LONG                        !Selected forground color
LIN:ActualCost_SelectedBG LONG                        !Selected background color
LIN:BillPrice          LIKE(LIN:BillPrice)            !List box control field - type derived from field
LIN:BillPrice_NormalFG LONG                           !Normal forground color
LIN:BillPrice_NormalBG LONG                           !Normal background color
LIN:BillPrice_SelectedFG LONG                         !Selected forground color
LIN:BillPrice_SelectedBG LONG                         !Selected background color
LIN:ItemTypeCode       LIKE(LIN:ItemTypeCode)         !List box control field - type derived from field
LIN:Quantity           LIKE(LIN:Quantity)             !List box control field - type derived from field
LIN:Description        LIKE(LIN:Description)          !List box control field - type derived from field
VEN:CompanyName        LIKE(VEN:CompanyName)          !List box control field - type derived from field
VEN:CompanyName_NormalFG LONG                         !Normal forground color
VEN:CompanyName_NormalBG LONG                         !Normal background color
VEN:CompanyName_SelectedFG LONG                       !Selected forground color
VEN:CompanyName_SelectedBG LONG                       !Selected background color
LIN:EventNumber        LIKE(LIN:EventNumber)          !Primary key field - type derived from field
LIN:LineNumber         LIKE(LIN:LineNumber)           !Primary key field - type derived from field
VEN:VendorNumber       LIKE(VEN:VendorNumber)         !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::EVE:Record  LIKE(EVE:RECORD),STATIC
QuickWindow          WINDOW('Update an Event'),AT(,,326,198),FONT('MS Sans Serif',8,,),CENTER,HLP('~UpdateEvent'),SYSTEM,GRAY,DOUBLE,MDI
                       SHEET,AT(7,6,317,171),USE(?CurrentTab)
                         TAB('&Event'),USE(?Tab4)
                           PROMPT('&Event :'),AT(30,23),USE(?EVE:Description:Prompt)
                           ENTRY(@S25),AT(56,23,104,10),USE(EVE:Description),MSG('Description of the Event'),REQ
                           PROMPT('&Date:'),AT(170,23),USE(?EVE:Date:Prompt)
                           SPIN(@d2),AT(192,23,55,10),USE(EVE:Date),RIGHT(1),MSG('Date the Event Takes Place'),STEP(1)
                           STRING(@s10),AT(254,26,65,10),USE(LOC:DayOfWeek)
                           PROMPT('&Sponser:'),AT(25,42),USE(?EVE:Sponser:Prompt)
                           ENTRY(@n4),AT(56,42,12,12),USE(EVE:Sponsor),RIGHT(1),MSG('Organization Giving the Event')
                           BUTTON,AT(72,42,12,12),USE(?CallLookup),MSG('Lookup the Sponsor'),TIP('Lookup the Sponsor'),KEY(AltL),ICON('LOOKUP.ICO')
                           STRING(@S25),AT(88,42),USE(SPO:CompanyName),FONT('MS Sans Serif',10,,FONT:bold)
                           PROMPT('&Max Tables:'),AT(14,63),USE(?EVE:MaxTables:Prompt)
                           SPIN(@n2),AT(56,63,27,10),USE(EVE:MaxTables),RANGE(1,20),STEP(1)
                           PROMPT('Seats Per &Table:'),AT(88,63),USE(?EVE:SeatsPerTable:Prompt)
                           SPIN(@n2),AT(146,63,27,10),USE(EVE:SeatsPerTable),RANGE(1,20),STEP(1)
                           GROUP('&Notes:'),AT(16,86,304,81),USE(?Group1),BOXED
                           END
                           TEXT,AT(22,95,293,64),USE(EVE:Notes),VSCROLL,MSG('Special Instructions or Notes about the Event')
                         END
                         TAB('&Line Items'),USE(?Tab1)
                           LIST,AT(11,23,309,135),USE(?Browse:4),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('45D(12)|*~Budget Cost~L(2)@n7.2@41D(12)|*~Actual Cost~L(2)@n7.2@39D(12)|*~Bill P' &|
   'rice~L(2)@n7.2@30L(2)|M~Type~@s10@18R(2)|M~#~C(0)@n3@57L(2)|M~Description~@S25@5' &|
   '9L(2)|M*~Vendor~@S25@'),FROM(Queue:Browse:4)
                           BUTTON('Insert'),AT(254,117,16,14),USE(?Insert:5),HIDE,TIP('Add a Line Item')
                           BUTTON('Change'),AT(270,117,16,14),USE(?Change:5),HIDE,TIP('Change a Line Item')
                           BUTTON('Delete'),AT(286,117,16,14),USE(?Delete:5),HIDE,TIP('Remove a Line Item')
                           STRING(@n-9.2),AT(13,161),USE(BudgetTotal),FONT(,,COLOR:Navy,)
                           STRING(@n-9.2),AT(59,161),USE(ActualTotal),FONT(,,COLOR:Navy,)
                           STRING(@n-9.2),AT(105,161),USE(BilledTotal),FONT(,,COLOR:Navy,)
                         END
                         TAB('&Attendees && Tables'),USE(?Tab2)
                           LIST,AT(16,23,141,121),USE(?Browse:2),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('21L(2)|M~Table~C(0)@n2@200L(2)|M~Member Name~@s50@'),FROM(Queue:Browse:2),DROPID('''SelectMembers''')
                           PROMPT('Attendees'),AT(34,148),USE(?LOC:AttendeeCount:Prompt),FONT(,9,,)
                           STRING(@n3),AT(16,148),USE(LOC:AttendeeCount),FONT(,9,,)
                           BUTTON,AT(130,149,25,25),USE(?Button11),TIP('Assign Attendees to Tables'),KEY(F7Key),ICON('MEETING.ICO')
                           BUTTON,AT(103,149,25,25),USE(?Button12),TIP('Show List to Add Members to Event'),KEY(F8Key),ICON('MEMBER.ICO')
                           BUTTON,AT(77,149,25,25),USE(?Delete:3),TIP('Remove Attendee from this Event'),ICON('NO-MEMBR.ICO')
                           LIST,AT(169,74,139,36),USE(?List),IMM,VSCROLL,COLOR(COLOR:BTNFACE),MSG('Browsing Records'),FORMAT('40L|M@s10@80L|M@s20@'),FROM(Queue:Browse)
                           PANEL,AT(161,24,152,102),USE(?Panel1),BEVEL(-1,-1)
                           TEXT,AT(168,28,141,41),USE(LOC:FullAddress),SKIP,COLOR(COLOR:BTNFACE),READONLY
                         END
                       END
                       BUTTON('OK'),AT(172,181,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(223,181,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(275,181,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
TakeNewSelection       PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)               !Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetFromView          PROCEDURE(),DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW2::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW2::Sort0:StepClass StepLongClass                   !Default Step Manager
BRW10                CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
                     END

BRW10::Sort0:Locator StepLocatorClass                 !Default Locator
BRW10::Sort0:StepClass StepLongClass                  !Default Step Manager
BRW4                 CLASS(BrowseClass)               !Browse using ?Browse:4
Q                      &Queue:Browse:4                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetFromView          PROCEDURE(),DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW4::Sort0:StepClass StepLongClass                   !Default Step Manager
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()

DropMemberOnAttendeeList ROUTINE
  CLEAR(ATT:RECORD)
  ATT:EventNumber=EVE:Number
  ATT:TableNumber=0
  ATT:Attendee=CLIPBOARD()
  GET(Attendees,0)
  IF Access:Attendees.TryInsert() = Level:Notify  !Check if member already attending
    MESSAGE('This person is already attending','',ICON:Exclamation,BUTTON:OK,)
  ELSE
    BRW2.ResetSort(1)
    BRW2.ResetFromView
  END
  DO LocateRecordAfterDrop
!!Set Highlight bar to current record after drop
LocateRecordAfterDrop  ROUTINE
  ATT:Attendee = CLIPBOARD()
  BRW2.Reset(2)
  BRW2.ResetQueue(Reset:Done)
  ThisWindow.Reset(TRUE)
!count seats taken at each table (except table zero)
CountSeats ROUTINE
 CLEAR(Loc:SeatCounter)                              !Clear the array
 ATT:EventNumber=LOC:EventNumber                      !Set Key Component values
 ATT:TableNumber=1
 ATT:Attendee=0
 SET(ATT:KeyEventTableAttendee,ATT:KeyEventTableAttendee)  !set key position
 LOOP UNTIL Access:Attendees.Next()
   IF ATT:EventNumber <> LOC:EventNumber THEN BREAK.       !Break out when reaches next event
   IF ATT:TableNumber
     Loc:SeatCounter[ATT:TableNumber] += 1                 ! increment the appropriate counter
   END
 END
!Get Highest Seat count in use
GetMaxSeats  ROUTINE
  LOC:HighSeatCounter =0
  LOOP i# = 1 TO 20
    IF LOC:HighSeatCounter < Loc:SeatCounter[i#]
      LOC:HighSeatCounter = Loc:SeatCounter[i#]
    END
  END
!Get Highest table with people seated
!Used to prevent decreasing number of tables below tables in use
CheckHighestTable  ROUTINE
  LOOP i#= 20 to (EVE:MaxTables +1) BY -1
    ATT:EventNumber = LOC:EventNumber
    ATT:TableNumber = i#
    ATT:Attendee = 0
    SET(ATT:KeyEventTableAttendee,ATT:KeyEventTableAttendee)
    Access:Attendees.Next()
    IF ATT:TableNumber = i# AND ATT:EventNumber = LOC:EventNumber AND ATT:Attendee <>0
     MESSAGE('You have people at table ' & i# )
     EVE:MaxTables = LOC:Saved:MaxTables
     SELECT(?EVE:MaxTables)
     BREAK
    END
  END

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding an Event'
  OF ChangeRecord
    ActionMessage = 'Changing an Event'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateEvents')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?EVE:Description:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  !Save Initial Values
  LOC:EventNumber=EVE:Number
  LOC:Saved:SeatsPerTable = EVE:SeatsPerTable
  LOC:Saved:MaxTables     = EVE:MaxTables
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  LOC:DayOfWeek = DOW(EVE:Date)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(EVE:Record,History::EVE:Record)
  SELF.AddHistoryField(?EVE:Description,2)
  SELF.AddHistoryField(?EVE:Date,3)
  SELF.AddHistoryField(?EVE:Sponsor,4)
  SELF.AddHistoryField(?EVE:MaxTables,5)
  SELF.AddHistoryField(?EVE:SeatsPerTable,6)
  SELF.AddHistoryField(?EVE:Notes,7)
  SELF.AddUpdateFile(Access:Events)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:Attendees.Open
  Access:Sponsor.UseFile
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Events
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:Attendees,SELF)
  BRW10.Init(?List,Queue:Browse.ViewPosition,BRW10::View:Browse,Queue:Browse,Relate:MPhones,SELF)
  BRW4.Init(?Browse:4,Queue:Browse:4.ViewPosition,BRW4::View:Browse,Queue:Browse:4,Relate:LineItems,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowNumeric)
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,ATT:KeyEventAttendee)
  BRW2.AddRange(ATT:EventNumber,Relate:Attendees,Relate:Events)
  BRW2.AddLocator(BRW2::Sort0:Locator)
  BRW2::Sort0:Locator.Init(,ATT:Attendee,1,BRW2)
  BIND('LOC:MemberName',LOC:MemberName)
  BIND('LOC:CSZ',LOC:CSZ)
  BIND('LOC:FullAddress',LOC:FullAddress)
  BRW2.AddField(ATT:TableNumber,BRW2.Q.ATT:TableNumber)
  BRW2.AddField(LOC:MemberName,BRW2.Q.LOC:MemberName)
  BRW2.AddField(MEM:Address,BRW2.Q.MEM:Address)
  BRW2.AddField(MEM:Address2,BRW2.Q.MEM:Address2)
  BRW2.AddField(LOC:CSZ,BRW2.Q.LOC:CSZ)
  BRW2.AddField(LOC:FullAddress,BRW2.Q.LOC:FullAddress)
  BRW2.AddField(ATT:EventNumber,BRW2.Q.ATT:EventNumber)
  BRW2.AddField(ATT:Attendee,BRW2.Q.ATT:Attendee)
  BRW2.AddField(MEM:MemberNumber,BRW2.Q.MEM:MemberNumber)
  BRW10.Q &= Queue:Browse
  BRW10::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW10.AddSortOrder(BRW10::Sort0:StepClass,MPH:KeyMemberNumber)
  BRW10.AddRange(MPH:MemberNumber,Relate:MPhones,Relate:Members)
  BRW10.AddLocator(BRW10::Sort0:Locator)
  BRW10::Sort0:Locator.Init(,MPH:MemberNumber,1,BRW10)
  BRW10.AddField(MPH:Description,BRW10.Q.MPH:Description)
  BRW10.AddField(MPH:PhoneNumber,BRW10.Q.MPH:PhoneNumber)
  BRW10.AddField(MPH:MemberNumber,BRW10.Q.MPH:MemberNumber)
  BRW4.Q &= Queue:Browse:4
  BRW4::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW4.AddSortOrder(BRW4::Sort0:StepClass,LIN:KeyEventNumber)
  BRW4.AddRange(LIN:EventNumber,Relate:LineItems,Relate:Events)
  BRW4.AddField(LIN:BudgetCost,BRW4.Q.LIN:BudgetCost)
  BRW4.AddField(LIN:ActualCost,BRW4.Q.LIN:ActualCost)
  BRW4.AddField(LIN:BillPrice,BRW4.Q.LIN:BillPrice)
  BRW4.AddField(LIN:ItemTypeCode,BRW4.Q.LIN:ItemTypeCode)
  BRW4.AddField(LIN:Quantity,BRW4.Q.LIN:Quantity)
  BRW4.AddField(LIN:Description,BRW4.Q.LIN:Description)
  BRW4.AddField(VEN:CompanyName,BRW4.Q.VEN:CompanyName)
  BRW4.AddField(LIN:EventNumber,BRW4.Q.LIN:EventNumber)
  BRW4.AddField(LIN:LineNumber,BRW4.Q.LIN:LineNumber)
  BRW4.AddField(VEN:VendorNumber,BRW4.Q.VEN:VendorNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('UpdateEvents',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  GLO:AttendeeList =?Browse:2      ! save control number
  
  BRW2.AskProcedure = 2
  BRW4.AskProcedure = 3
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  BRW10.AddToolbarTarget(Toolbar)
  BRW10.ToolbarItem.HelpButton = ?Help
  BRW4.AddToolbarTarget(Toolbar)
  BRW4.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Attendees.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateEvents',QuickWindow)
  END
  !!Close the Toolbox if it is open
  IF GLO:Running:ShowMemberToolbox
    POST(Event:CloseWindow,,GLO:Running:ShowMemberToolbox)
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.PrimeFields PROCEDURE

  CODE
    EVE:MaxTables = DefaultMaxTables
    EVE:SeatsPerTable = DefaultSeatsPerTable
    SPO:CompanyName = ''
  PARENT.PrimeFields


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectSponsor
      UpdateAttendees
      UpdateLineItems
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?EVE:Date
      ThisWindow.Reset  ! to update the day of week display
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?EVE:Sponsor
      IF QuickWindow{Prop:AcceptAll} = False
        SPO:SponsorNumber = EVE:Sponsor
        IF Access:Sponsor.TryFetch(SPO:KeySponsorNumber)
          IF SELF.Run(1,SelectRecord) = RequestCompleted
            EVE:Sponsor = SPO:SponsorNumber
          ELSE
            SELECT(?EVE:Sponsor)
            CYCLE
          END
        END
      END
      ThisWindow.Reset(0)
      IF Access:Events.TryValidateField(4)
        SELECT(?EVE:Sponsor)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EVE:Sponsor
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?EVE:Sponsor{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?CallLookup
      ThisWindow.Update
      SPO:SponsorNumber = EVE:Sponsor
      IF SELF.Run(1,SelectRecord) = RequestCompleted
        EVE:Sponsor = SPO:SponsorNumber
      END
      ThisWindow.Reset(1)
    OF ?EVE:MaxTables
      !Check for highest table in use
       IF EVE:MaxTables < LOC:Saved:MaxTables
          DO CheckHighestTable
       END
      
    OF ?EVE:SeatsPerTable
      !Check seats counts at tables if value decreased
       IF EVE:SeatsPerTable < LOC:Saved:SeatsPerTable
       DO CountSeats
       DO GetMaxSeats
         IF EVE:SeatsPerTable < LOC:HighSeatCounter
           MESSAGE('You have ' & LOC:HighSeatCounter & ' attendees at a table')
           EVE:SeatsPerTable = LOC:Saved:SeatsPerTable
           SELECT(?EVE:SeatsPerTable)
         END
       END
      
    OF ?Button11
      ThisWindow.Update
      AssignTables
      ThisWindow.Reset
      BRW2.ResetSort(1)
      
    OF ?Button12
      ThisWindow.Update
      !Toggle Show Member List button
      IF GLO:Running:ShowMemberToolbox
        POST(Event:CloseWindow,,GLO:Running:ShowMemberToolbox)
        ?Button12{Prop:Icon}='member.ico'
        ?Button12{Prop:Tooltip}='Show Member List'
      ELSE
        START(ShowMemberToolbox)
        ?Button12{Prop:Icon}='~hidememb.ico'
        ?Button12{Prop:Tooltip}='Hide Member List'
      END
      
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    Quickwindow{Prop:Text}= ACTIONMESSAGE & '--' & EVE:Description
  
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeFieldEvent()
  CASE FIELD()
  OF ?Browse:2
    CASE EVENT()
    OF EVENT:Drop
      DO DropMemberOnAttendeeList
      
    END
  END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeNewSelection PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?EVE:Date
      ThisWindow.Reset  ! to update the day of week display
    END
  ReturnValue = PARENT.TakeNewSelection()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.DeleteControl=?Delete:3
  END


BRW2.ResetFromView PROCEDURE

LOC:AttendeeCount:Cnt LONG
  CODE
  SETCURSOR(Cursor:Wait)
  Relate:Attendees.SetQuickScan(1)
  SELF.Reset
  LOOP
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      RETURN
    END
    SELF.SetQueueRecord
    LOC:AttendeeCount:Cnt += 1
  END
  !!Clear Display of CityStateZip hot field if last attendee deleted
  IF NOT RECORDS(QUEUE:BROWSE:2)
    LOC:CSZ = ''
    DISPLAY
  END
  
  LOC:AttendeeCount = LOC:AttendeeCount:Cnt
  PARENT.ResetFromView
  Relate:Attendees.SetQuickScan(0)
  SETCURSOR()


BRW2.SetQueueRecord PROCEDURE

  CODE
  LOC:MemberName = CLIP(MEM:LastName) & ', ' & CLIP(MEM:FirstName) & ' ' & MEM:MiddleName
  LOC:CSZ = CLIP(MEM:City) & ', ' & CLIP(MEM:State) & ' ' & MEM:ZIPCode
  IF (MEM:Address2)
    LOC:FullAddress = MEM:Address & '<13,10>' & MEM:Address2 & '<13,10>' & LOC:CSZ
  ELSE
    LOC:FullAddress = MEM:Address & '<13,10>' & LOC:CSZ
  END
  PARENT.SetQueueRecord
  SELF.Q.LOC:MemberName = LOC:MemberName              !Assign formula result to display queue
  SELF.Q.LOC:CSZ = LOC:CSZ                            !Assign formula result to display queue
  SELF.Q.LOC:FullAddress = LOC:FullAddress            !Assign formula result to display queue


BRW4.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:5
    SELF.ChangeControl=?Change:5
    SELF.DeleteControl=?Delete:5
  END


BRW4.ResetFromView PROCEDURE

BudgetTotal:Sum      REAL
ActualTotal:Sum      REAL
BilledTotal:Sum      REAL
  CODE
  SETCURSOR(Cursor:Wait)
  Relate:LineItems.SetQuickScan(1)
  SELF.Reset
  LOOP
    CASE SELF.Next()
    OF Level:Notify
      BREAK
    OF Level:Fatal
      RETURN
    END
    SELF.SetQueueRecord
    BudgetTotal:Sum += LIN:BudgetCost
    ActualTotal:Sum += LIN:ActualCost
    BilledTotal:Sum += LIN:BillPrice
  END
  BudgetTotal = BudgetTotal:Sum
  ActualTotal = ActualTotal:Sum
  BilledTotal = BilledTotal:Sum
  PARENT.ResetFromView
  Relate:LineItems.SetQuickScan(0)
  SETCURSOR()


BRW4.SetQueueRecord PROCEDURE

  CODE
  PARENT.SetQueueRecord
  SELF.Q.LIN:BudgetCost_NormalFG = -1
  SELF.Q.LIN:BudgetCost_NormalBG = -1
  SELF.Q.LIN:BudgetCost_SelectedFG = -1
  SELF.Q.LIN:BudgetCost_SelectedBG = -1
  IF (LIN:ActualCost > LIN:BudgetCost)
    SELF.Q.LIN:ActualCost_NormalFG = 255
    SELF.Q.LIN:ActualCost_NormalBG = -1
    SELF.Q.LIN:ActualCost_SelectedFG = -1
    SELF.Q.LIN:ActualCost_SelectedBG = -1
  ELSE
    SELF.Q.LIN:ActualCost_NormalFG = -1
    SELF.Q.LIN:ActualCost_NormalBG = -1
    SELF.Q.LIN:ActualCost_SelectedFG = -1
    SELF.Q.LIN:ActualCost_SelectedBG = -1
  END
  IF (LIN:BillPrice < LIN:ActualCost)
    SELF.Q.LIN:BillPrice_NormalFG = 255
    SELF.Q.LIN:BillPrice_NormalBG = -1
    SELF.Q.LIN:BillPrice_SelectedFG = -1
    SELF.Q.LIN:BillPrice_SelectedBG = -1
  ELSE
    SELF.Q.LIN:BillPrice_NormalFG = -1
    SELF.Q.LIN:BillPrice_NormalBG = -1
    SELF.Q.LIN:BillPrice_SelectedFG = -1
    SELF.Q.LIN:BillPrice_SelectedBG = -1
  END
  SELF.Q.VEN:CompanyName_NormalFG = -1
  SELF.Q.VEN:CompanyName_NormalBG = -1
  SELF.Q.VEN:CompanyName_SelectedFG = -1
  SELF.Q.VEN:CompanyName_SelectedBG = -1


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

SelectSponsor PROCEDURE                               !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(Sponsor)
                       PROJECT(SPO:CompanyName)
                       PROJECT(SPO:SponsorNumber)
                       PROJECT(SPO:Address)
                       PROJECT(SPO:City)
                       PROJECT(SPO:State)
                       PROJECT(SPO:Zip)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
SPO:CompanyName        LIKE(SPO:CompanyName)          !List box control field - type derived from field
SPO:SponsorNumber      LIKE(SPO:SponsorNumber)        !Browse hot field - type derived from field
SPO:Address            LIKE(SPO:Address)              !Browse hot field - type derived from field
SPO:City               LIKE(SPO:City)                 !Browse hot field - type derived from field
SPO:State              LIKE(SPO:State)                !Browse hot field - type derived from field
SPO:Zip                LIKE(SPO:Zip)                  !Browse hot field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW5::View:Browse    VIEW(SPhones)
                       PROJECT(SPH:Description)
                       PROJECT(SPH:PhoneNumber)
                       PROJECT(SPH:SponsorNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
SPH:Description        LIKE(SPH:Description)          !List box control field - type derived from field
SPH:PhoneNumber        LIKE(SPH:PhoneNumber)          !List box control field - type derived from field
SPH:SponsorNumber      LIKE(SPH:SponsorNumber)        !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a Sponsor'),AT(,,315,185),FONT('MS Sans Serif',8,,),HLP('~SelectSponsor'),SYSTEM,GRAY,RESIZE,MDI
                       LIST,AT(8,20,122,142),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('80L(2)|M~Company Name~@S25@'),FROM(Queue:Browse:1)
                       SHEET,AT(4,4,308,180),USE(?CurrentTab)
                         TAB('Sponsors'),USE(?Tab:2)
                           PANEL,AT(136,22,163,138),USE(?Panel1),BEVEL(-1,-1)
                           STRING(@n4),AT(214,25),USE(SPO:SponsorNumber),RIGHT(1)
                           PROMPT('&Sponsor Number:'),AT(147,26),USE(?SPO:SponsorNumber:Prompt)
                           STRING(@S40),AT(147,41),USE(SPO:Address)
                           STRING(@S25),AT(147,52),USE(SPO:City)
                           STRING(@s2),AT(148,65),USE(SPO:State)
                           STRING(@s10),AT(163,65),USE(SPO:Zip),RIGHT(1)
                           LIST,AT(145,103,145,39),USE(?List),IMM,VSCROLL,COLOR(COLOR:BTNFACE),MSG('Browsing Records'),FORMAT('40L|M@s10@80L|M@s20@'),FROM(Queue:Browse)
                           BUTTON('&Select'),AT(10,167,45,14),USE(?Select:2)
                         END
                       END
                       BUTTON('Close'),AT(183,165,45,14),USE(?Close),HIDE
                       BUTTON('Help'),AT(242,167,45,14),USE(?Help),HIDE,STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
BRW5                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
                     END

BRW5::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW5::Sort0:StepClass StepLongClass                   !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectSponsor')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:SPhones.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Sponsor,SELF)
  BRW5.Init(?List,Queue:Browse.ViewPosition,BRW5::View:Browse,Queue:Browse,Relate:SPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,SPO:KeyCompanyName)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,SPO:CompanyName,1,BRW1)
  BRW1.AddField(SPO:CompanyName,BRW1.Q.SPO:CompanyName)
  BRW1.AddField(SPO:SponsorNumber,BRW1.Q.SPO:SponsorNumber)
  BRW1.AddField(SPO:Address,BRW1.Q.SPO:Address)
  BRW1.AddField(SPO:City,BRW1.Q.SPO:City)
  BRW1.AddField(SPO:State,BRW1.Q.SPO:State)
  BRW1.AddField(SPO:Zip,BRW1.Q.SPO:Zip)
  BRW5.Q &= Queue:Browse
  BRW5::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW5.AddSortOrder(BRW5::Sort0:StepClass,SPH:KeySponsorNumber)
  BRW5.AddRange(SPH:SponsorNumber,Relate:SPhones,Relate:Sponsor)
  BRW5.AddLocator(BRW5::Sort0:Locator)
  BRW5::Sort0:Locator.Init(,SPH:SponsorNumber,1,BRW5)
  BRW5.AddField(SPH:Description,BRW5.Q.SPH:Description)
  BRW5.AddField(SPH:PhoneNumber,BRW5.Q.SPH:PhoneNumber)
  BRW5.AddField(SPH:SponsorNumber,BRW5.Q.SPH:SponsorNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('SelectSponsor',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  BRW5.AddToolbarTarget(Toolbar)
  BRW5.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:SPhones.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectSponsor',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

UpdateAttendees PROCEDURE                             !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
History::ATT:Record  LIKE(ATT:RECORD),STATIC
QuickWindow          WINDOW('Update an Attendee'),AT(,,198,133),FONT('MS Sans Serif',8,,),IMM,HLP('~UpdateAttendee'),SYSTEM,GRAY,RESIZE,MDI
                       PROMPT('&Event Number:'),AT(8,2),USE(?ATT:EventNumber:Prompt)
                       STRING(@n4),AT(68,2,40,10),USE(ATT:EventNumber)
                       STRING(@S25),AT(103,1,86,10),USE(EVE:Description)
                       PROMPT('&Table Number:'),AT(3,16,53,10),USE(?ATT:TableNumber:Prompt)
                       STRING(@n1),AT(68,16,19,10),USE(ATT:TableNumber)
                       PROMPT('&Attendee:'),AT(24,48),USE(?ATT:Attendee:Prompt)
                       ENTRY(@n4),AT(68,48,19,10),USE(ATT:Attendee),RIGHT(1)
                       STRING(@s25),AT(17,64),USE(MEM:LastName)
                       STRING(@s20),AT(19,76,101,10),USE(MEM:FirstName)
                       BUTTON('OK'),AT(53,113,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(102,113,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(151,113,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateAttendees')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?ATT:EventNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(ATT:Record,History::ATT:Record)
  SELF.AddHistoryField(?ATT:EventNumber,1)
  SELF.AddHistoryField(?ATT:TableNumber,2)
  SELF.AddHistoryField(?ATT:Attendee,3)
  SELF.AddUpdateFile(Access:Attendees)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:Attendees.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Attendees
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  OPEN(QuickWindow)
  SELF.Opened=True
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Attendees.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?ATT:Attendee
      IF Access:Attendees.TryValidateField(3)
        SELECT(?ATT:Attendee)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?ATT:Attendee
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?ATT:Attendee{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

BrowseStates PROCEDURE                                !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(States)
                       PROJECT(ST:StateCode)
                       PROJECT(ST:StateName)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
ST:StateCode           LIKE(ST:StateCode)             !List box control field - type derived from field
ST:StateName           LIKE(ST:StateName)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select State'),AT(,,159,121),FONT('MS Sans Serif',8,,),IMM,HLP('~SelectState'),SYSTEM,GRAY,RESIZE,MDI
                       LIST,AT(8,6,143,91),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('44L(2)|M~State Code~L(2)@s2@80L(2)|M~State Name~L(2)@s20@'),FROM(Queue:Browse:1)
                       BUTTON('&Insert'),AT(13,61,30,14),USE(?Insert:2),HIDE
                       BUTTON('&Change'),AT(48,61,28,14),USE(?Change:2),HIDE,DEFAULT
                       BUTTON('&Delete'),AT(81,62,30,14),USE(?Delete:2),HIDE
                       BUTTON('Help'),AT(110,102,45,14),USE(?Help),STD(STD:Help)
                       BUTTON('&Select'),AT(23,103),USE(?Select)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseStates')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:States.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:States,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,ST:StateKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,ST:StateCode,1,BRW1)
  BRW1.AddField(ST:StateCode,BRW1.Q.ST:StateCode)
  BRW1.AddField(ST:StateName,BRW1.Q.ST:StateName)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('BrowseStates',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:States.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseStates',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

UpdateVendor PROCEDURE                                !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
BRW5::View:Browse    VIEW(VPhones)
                       PROJECT(VPH:Description)
                       PROJECT(VPH:PhoneNumber)
                       PROJECT(VPH:VendorNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VPH:Description        LIKE(VPH:Description)          !List box control field - type derived from field
VPH:PhoneNumber        LIKE(VPH:PhoneNumber)          !List box control field - type derived from field
VPH:VendorNumber       LIKE(VPH:VendorNumber)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::VEN:Record  LIKE(VEN:RECORD),STATIC
QuickWindow          WINDOW('Update Vendor'),AT(,,211,194),FONT('MS Sans Serif',8,,),IMM,HLP('~UpdateVendor'),SYSTEM,GRAY,RESIZE,MDI
                       PROMPT('Number:'),AT(8,7),USE(?VEN:VendorNumber:Prompt)
                       STRING(@n4),AT(47,7,40,10),USE(VEN:VendorNumber),FONT(,,,FONT:bold)
                       PROMPT('&Company:'),AT(4,20),USE(?VEN:CompanyName:Prompt)
                       ENTRY(@S25),AT(47,20,104,10),USE(VEN:CompanyName),REQ
                       PROMPT('&Address:'),AT(8,34),USE(?VEN:Address:Prompt)
                       ENTRY(@S40),AT(47,34,153,10),USE(VEN:Address)
                       ENTRY(@S40),AT(47,48,151,10),USE(VEN:Address2)
                       PROMPT('Address&2:'),AT(4,50),USE(?VEN:Address2:Prompt)
                       PROMPT('Ci&ty:'),AT(22,62),USE(?VEN:City:Prompt)
                       ENTRY(@S25),AT(47,62,104,10),USE(VEN:City)
                       PROMPT('&State:'),AT(16,75),USE(?VEN:State:Prompt)
                       ENTRY(@s2),AT(47,75,40,10),USE(VEN:State)
                       PROMPT('&Zip:'),AT(100,75),USE(?VEN:Zip:Prompt)
                       ENTRY(@s10),AT(123,75,44,10),USE(VEN:Zip),RIGHT(1)
                       GROUP('&Phones:'),AT(17,106,188,57),USE(?Group1),BOXED
                         BUTTON,AT(26,116,16,14),USE(?Insert),TIP('Add a Phone Number'),ICON('INSERT.ICO')
                         BUTTON,AT(26,130,16,14),USE(?Change),TIP('Change a Phone Number'),ICON('EDIT.ICO')
                         BUTTON,AT(26,144,16,14),USE(?Delete),TIP('Delete a Phone Number'),ICON('DELETE.ICO')
                       END
                       LIST,AT(47,116,150,42),USE(?List),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('40L|M~Description~@s10@80L~Number~@s20@'),FROM(Queue:Browse)
                       BUTTON('OK'),AT(31,174,45,14),USE(?OK),TIP('Save the Vendor Record'),DEFAULT
                       BUTTON('Cancel'),AT(83,174,45,14),USE(?Cancel),TIP('Cancel changes to the record')
                       BUTTON('Help'),AT(135,174,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

BRW5                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW5::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW5::EIPManager     BrowseEIPManager                 !Browse EIP Manager for Browse using ?List
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Vendor '
  OF ChangeRecord
    ActionMessage = 'Changing  Vendor Information'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateVendor')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?VEN:VendorNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(VEN:Record,History::VEN:Record)
  SELF.AddHistoryField(?VEN:VendorNumber,1)
  SELF.AddHistoryField(?VEN:CompanyName,2)
  SELF.AddHistoryField(?VEN:Address,3)
  SELF.AddHistoryField(?VEN:Address2,4)
  SELF.AddHistoryField(?VEN:City,5)
  SELF.AddHistoryField(?VEN:State,6)
  SELF.AddHistoryField(?VEN:Zip,7)
  SELF.AddUpdateFile(Access:Vendor)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:States.Open
  Relate:VPhones.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Vendor
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW5.Init(?List,Queue:Browse.ViewPosition,BRW5::View:Browse,Queue:Browse,Relate:VPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  BRW5.Q &= Queue:Browse
  BRW5.AddSortOrder(,VPH:KeyVendorNumber)
  BRW5.AddRange(VPH:VendorNumber,Relate:VPhones,Relate:Vendor)
  BRW5.AddLocator(BRW5::Sort0:Locator)
  BRW5::Sort0:Locator.Init(,VPH:VendorNumber,1,BRW5)
  BRW5.AddField(VPH:Description,BRW5.Q.VPH:Description)
  BRW5.AddField(VPH:PhoneNumber,BRW5.Q.VPH:PhoneNumber)
  BRW5.AddField(VPH:VendorNumber,BRW5.Q.VPH:VendorNumber)
  INIMgr.Fetch('UpdateVendor',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:States.Close
    Relate:VPhones.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateVendor',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.PrimeFields PROCEDURE

  CODE
    VEN:City = DefaultCity
    VEN:State = DefaultState
    VEN:Zip = DefaultZIP
  PARENT.PrimeFields


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    BrowseStates
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?VEN:State
      IF VEN:State OR ?VEN:State{Prop:Req}
        ST:StateCode = VEN:State
        IF Access:States.TryFetch(ST:StateKey)
          IF SELF.Run(1,SelectRecord) = RequestCompleted
            VEN:State = ST:StateCode
          ELSE
            SELECT(?VEN:State)
            CYCLE
          END
        END
      END
      ThisWindow.Reset(0)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    Quickwindow{Prop:Text}= ACTIONMESSAGE & '--' & VEN:CompanyName
  
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:OpenWindow
      Toolbar.SetTarget(-1)
    END
  ReturnValue = PARENT.TakeWindowEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults


BRW5.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW5::EIPManager
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

Eventmgr_BrowseVendors PROCEDURE                      !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LOC:Running:BrowseVendors LONG(0)
LOC:FullAddress      STRING(200)
BRW1::View:Browse    VIEW(Vendor)
                       PROJECT(VEN:CompanyName)
                       PROJECT(VEN:VendorNumber)
                       PROJECT(VEN:Address)
                       PROJECT(VEN:Address2)
                       PROJECT(VEN:City)
                       PROJECT(VEN:State)
                       PROJECT(VEN:Zip)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
VEN:CompanyName        LIKE(VEN:CompanyName)          !List box control field - type derived from field
VEN:VendorNumber       LIKE(VEN:VendorNumber)         !Browse hot field - type derived from field
VEN:Address            LIKE(VEN:Address)              !Browse hot field - type derived from field
VEN:Address2           LIKE(VEN:Address2)             !Browse hot field - type derived from field
VEN:City               LIKE(VEN:City)                 !Browse hot field - type derived from field
VEN:State              LIKE(VEN:State)                !Browse hot field - type derived from field
VEN:Zip                LIKE(VEN:Zip)                  !Browse hot field - type derived from field
LOC:FullAddress        LIKE(LOC:FullAddress)          !Browse hot field - type derived from local data
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW6::View:Browse    VIEW(VPhones)
                       PROJECT(VPH:Description)
                       PROJECT(VPH:PhoneNumber)
                       PROJECT(VPH:VendorNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VPH:Description        LIKE(VPH:Description)          !List box control field - type derived from field
VPH:PhoneNumber        LIKE(VPH:PhoneNumber)          !List box control field - type derived from field
VPH:VendorNumber       LIKE(VPH:VendorNumber)         !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse Vendors'),AT(,,286,168),FONT('MS Sans Serif',8,,),ICON('VENDOR.ICO'),HLP('~BrowseVendors'),SYSTEM,GRAY,RESIZE,MDI,IMM
                       LIST,AT(8,20,115,141),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('80L(2)|M~Company Name~S(20)@S25@'),FROM(Queue:Browse:1)
                       SHEET,AT(4,4,280,162),USE(?CurrentTab)
                         TAB('Vendors By Company Name')
                           PANEL,AT(130,21,149,116),USE(?Panel1),BEVEL(-1,-1)
                           TEXT,AT(137,27,138,37),USE(LOC:FullAddress),SKIP,COLOR(COLOR:BTNFACE),READONLY
                           LIST,AT(138,74,137,50),USE(?List),IMM,VSCROLL,COLOR(COLOR:BTNFACE),MSG('Browsing Records'),FORMAT('40L|@s10@80L|@s20@'),FROM(Queue:Browse)
                           BUTTON('&Select'),AT(133,147,45,14),USE(?Select)
                           BUTTON('Close'),AT(183,147,45,14),USE(?Close)
                           BUTTON('Help'),AT(233,147,45,14),USE(?Help),STD(STD:Help)
                         END
                       END
                       BUTTON('&Insert'),AT(27,116,20,14),USE(?Insert:2),HIDE
                       BUTTON('&Change'),AT(49,116,20,14),USE(?Change:2),HIDE,DEFAULT
                       BUTTON('&Delete'),AT(75,116,20,14),USE(?Delete:2),HIDE
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
BRW6                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
                     END

BRW6::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW6::Sort0:StepClass StepLongClass                   !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_BrowseVendors')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  ALERT(F3Key,F6Key)
  !!Limit to only one instance
   IF GlobalRequest<>SelectRecord
    IF NOT GLO:Running:BrowseVendors     !If its not running
      GLO:Running:BrowseVendors=THREAD()  !Set global var to indicate this instance is running
      LOC:Running:BrowseVendors=THREAD()  !Set Local var to indicate this instance is running
    ELSE                                 !If it is running
      POST(Event:GainFocus,,GLO:Running:BrowseVendors) !bring to front
      RETURN Level:Fatal  !don't continute this with this instance
    END
   END
  
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:VPhones.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:Vendor,SELF)
  BRW6.Init(?List,Queue:Browse.ViewPosition,BRW6::View:Browse,Queue:Browse,Relate:VPhones,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,VEN:KeyCompanyName)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,VEN:CompanyName,1,BRW1)
  BIND('LOC:FullAddress',LOC:FullAddress)
  BRW1.AddField(VEN:CompanyName,BRW1.Q.VEN:CompanyName)
  BRW1.AddField(VEN:VendorNumber,BRW1.Q.VEN:VendorNumber)
  BRW1.AddField(VEN:Address,BRW1.Q.VEN:Address)
  BRW1.AddField(VEN:Address2,BRW1.Q.VEN:Address2)
  BRW1.AddField(VEN:City,BRW1.Q.VEN:City)
  BRW1.AddField(VEN:State,BRW1.Q.VEN:State)
  BRW1.AddField(VEN:Zip,BRW1.Q.VEN:Zip)
  BRW1.AddField(LOC:FullAddress,BRW1.Q.LOC:FullAddress)
  BRW6.Q &= Queue:Browse
  BRW6::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW6.AddSortOrder(BRW6::Sort0:StepClass,VPH:KeyVendorNumber)
  BRW6.AddRange(VPH:VendorNumber,Relate:VPhones,Relate:Vendor)
  BRW6.AddLocator(BRW6::Sort0:Locator)
  BRW6::Sort0:Locator.Init(,VPH:VendorNumber,1,BRW6)
  BRW6.AddField(VPH:Description,BRW6.Q.VPH:Description)
  BRW6.AddField(VPH:PhoneNumber,BRW6.Q.VPH:PhoneNumber)
  BRW6.AddField(VPH:VendorNumber,BRW6.Q.VPH:VendorNumber)
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Eventmgr_BrowseVendors',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  BRW6.AddToolbarTarget(Toolbar)
  BRW6.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:VPhones.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_BrowseVendors',QuickWindow)
  END
  !!Reset Thread Limiting flag
  IF LOC:Running:BrowseVendors
     GLO:Running:BrowseVendors=0
  END
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    UpdateVendor
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE EVENT()
    OF EVENT:AlertKey
      !Handle All Procedure HotKeys
      CASE KEYCODE()
        OF F3Key
            POST(EVENT:Accepted,GLO:MemberButton,GLO:AppFrameThread)
        OF F4Key
            POST(EVENT:Accepted,GLO:VendorButton,GLO:AppFrameThread)
        OF F5Key
            POST(EVENT:Accepted,GLO:EventButton,GLO:AppFrameThread)
        OF F6Key
            POST(EVENT:Accepted,GLO:SponsorButton,GLO:AppFrameThread)
      END
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:GainFocus
      !!Bring to front and restore to normal size if iconized
      quickwindow{PROP:Active}=TRUE
      IF quickwindow{PROP:Iconize}=TRUE
        quickwindow{PROP:Iconize}=''
      END
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.SetQueueRecord PROCEDURE

  CODE
  IF (VEN:Address2)
    LOC:FullAddress = VEN:Address & '<13,10>' & VEN:Address2 & '<13,10>' & CLIP(VEN:City) & ', ' & VEN:State & '  ' & VEN:Zip
  ELSE
    LOC:FullAddress = VEN:Address & '<13,10>' & CLIP(VEN:City) & ', ' & VEN:State & '  ' & VEN:Zip
  END
  PARENT.SetQueueRecord
  SELF.Q.LOC:FullAddress = LOC:FullAddress            !Assign formula result to display queue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

UpdateLineItems PROCEDURE                             !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
LOC:MemberName       STRING(40)
Queue:FileDropCombo  QUEUE                            !Queue declaration for browse/combo box using ?LIN:ItemTypeCode
TYP:TypeCode           LIKE(TYP:TypeCode)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
FDCB7::View:FileDropCombo VIEW(VendorType)
                       PROJECT(TYP:TypeCode)
                     END
QuickWindow          WINDOW('Update a LineItem'),AT(,,247,154),FONT('MS Sans Serif',8,,),IMM,HLP('~UpdateLineItem'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,232,128),USE(?CurrentTab)
                         TAB('General')
                           PROMPT('Event:'),AT(8,20),USE(?LIN:EventNumber:Prompt)
                           STRING(@S25),AT(57,22),USE(EVE:Description)
                           PROMPT('&Item Type:'),AT(8,34),USE(?LIN:ItemTypeCode:Prompt)
                           COMBO(@s10),AT(67,34,85,10),USE(LIN:ItemTypeCode),MSG('Select an Item Type for the list or enter a new one'),FORMAT('40L~Type~@s10@'),DROP(5),FROM(Queue:FileDropCombo)
                           PROMPT('&Quantity:'),AT(8,48),USE(?LIN:Quantity:Prompt)
                           SPIN(@n3),AT(68,48,40,10),USE(LIN:Quantity),RIGHT(1),MSG('Number of Items for this Line'),RANGE(1,999),STEP(1)
                           PROMPT('&Description:'),AT(8,62),USE(?LIN:Description:Prompt)
                           ENTRY(@S25),AT(68,62,161,10),USE(LIN:Description),MSG('Description of this Line Item'),REQ
                           PROMPT('&Vendor:'),AT(8,76),USE(?LIN:Vendor:Prompt)
                           ENTRY(@n4),AT(68,76,16,10),USE(LIN:Vendor),RIGHT(1),MSG('Vendor Number')
                           STRING(@S25),AT(103,77),USE(VEN:CompanyName)
                           BUTTON,AT(85,75,12,12),USE(?CallLookup),MSG('Select a Vendor'),TIP('Select a Vendor'),KEY(F2Key),ICON('LOOKUP.ICO')
                           PROMPT('&Budget Cost:'),AT(8,90),USE(?LIN:BudgetCost:Prompt)
                           SPIN(@n7.2),AT(68,90,47,10),USE(LIN:BudgetCost),DECIMAL(12),MSG('Amount budgeted for this Item'),STEP(1)
                           PROMPT('&Actual Cost:'),AT(8,104),USE(?LIN:ActualCost:Prompt)
                           SPIN(@n7.2),AT(68,104,47,10),USE(LIN:ActualCost),DECIMAL(12),MSG('Actual Cost for this Item'),STEP(1)
                           PROMPT('Bill &Amount:'),AT(8,118),USE(?LIN:BillPrice:Prompt)
                           SPIN(@n7.2),AT(68,118,47,10),USE(LIN:BillPrice),DECIMAL(12),MSG('Amount to bill to the sponsor'),STEP(1)
                         END
                         TAB('Notes'),USE(?Tab2)
                           TEXT,AT(8,22,222,105),USE(LIN:Notes),VSCROLL,MSG('Special Instructions or Notes about the Item')
                         END
                       END
                       BUTTON('OK'),AT(33,136,45,14),USE(?OK),DEFAULT
                       BUTTON('Cancel'),AT(82,136,45,14),USE(?Cancel)
                       BUTTON('Help'),AT(131,136,45,14),USE(?Help),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

FDCB7                CLASS(FileDropComboClass)        !File drop combo manager
Q                      &Queue:FileDropCombo           !Reference to browse queue type
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Line Item'
  OF ChangeRecord
    ActionMessage = 'Changing a Line Item'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateLineItems')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?LIN:EventNumber:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddUpdateFile(Access:LineItems)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:Events.Open
  Access:Vendor.UseFile
  SELF.FilesOpened = True
  SELF.Primary &= Relate:LineItems
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.InsertAction = Insert:Query
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  OPEN(QuickWindow)
  SELF.Opened=True
  Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('UpdateLineItems',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  FDCB7.Init(LIN:ItemTypeCode,?LIN:ItemTypeCode,Queue:FileDropCombo.ViewPosition,FDCB7::View:FileDropCombo,Queue:FileDropCombo,Relate:VendorType,ThisWindow,GlobalErrors,1,1,0)
  FDCB7.Q &= Queue:FileDropCombo
  FDCB7.AddSortOrder()
  FDCB7.AddField(TYP:TypeCode,FDCB7.Q.TYP:TypeCode)
  FDCB7.AddUpdateField(TYP:TypeCode,LIN:ItemTypeCode)
  ThisWindow.AddItem(FDCB7.WindowComponent)
  FDCB7.DefaultFill = 0
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Events.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateLineItems',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    Eventmgr_BrowseVendors
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LIN:Vendor
      VEN:VendorNumber = LIN:Vendor
      IF Access:Vendor.TryFetch(VEN:KeyVendorNumber)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          LIN:Vendor = VEN:VendorNumber
        ELSE
          SELECT(?LIN:Vendor)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:LineItems.TryValidateField(6)
        SELECT(?LIN:Vendor)
        QuickWindow{Prop:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?LIN:Vendor
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ~ERRORCODE()
          ?LIN:Vendor{Prop:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?CallLookup
      ThisWindow.Update
      VEN:VendorNumber = LIN:Vendor
      IF SELF.Run(1,SelectRecord) = RequestCompleted
        LIN:Vendor = VEN:VendorNumber
      END
      ThisWindow.Reset(1)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    Quickwindow{Prop:Text}= ACTIONMESSAGE & '--' & EVE:Description
  
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

